<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/
// save new comment if we got one
include_once("config.inc.php");
include_once("startup_db.inc.php");
include_once("lib/geoip.inc.php");
$Blog->golive($db);

$ID = $_REQUEST['id'];
$gi = geoip_open("lib/GeoIP.dat",GEOIP_STANDARD);
$data = $_REQUEST['c'];

if(!empty($ID) && !empty($data))
{
  if(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
  {
    $data['ip'] = $_SERVER['HTTP_X_FORWARDED_FOR'];
    $data['hostname'] = $_SERVER['HTTP_VIA'];
  }
  else
  {
    $data['ip'] = $_SERVER['REMOTE_ADDR'];
    $data['hostname'] = gethostbyaddr($_SERVER['REMOTE_ADDR']);
  }

  $data['country'] = geoip_country_name_by_addr($gi, $_SERVER['REMOTE_ADDR']);

  // Strip tags and auto-paragraph
  $data['comment'] = strip_tags($data['comment'], '<a><b><i><u>');
  $data['comment'] = '<p>'.str_replace("\n","</p><p>",$data['comment']).'</p>';

  // Comment spam protection - check HTTP Referer
  $srvrAddr = str_replace("www.","",$Blog->settings['site_url']);
  $rfrAddr  = str_replace("www.","",$_SERVER['HTTP_REFERER']);
  if(strpos($rfrAddr, $srvrAddr) === false)
  {
    writeLog($db, "Comment spam by IP ".$data['ip']);
    exit;
  }

  if(!$Blog->isBanned($_SERVER['REMOTE_ADDR']) || $Blog->handle_banned == 'BAN_NONE')
  {
    if($_REQUEST['function'] == 'preview')
    {
          
      // else we're previewing
      $queryString = '&c[comment]='.urlencode(stripslashes($data['comment'])).'&c[guest]='.stripslashes($data['guest']).'&c[email]='. $data['email'].'&c[url]='.$data['url'];
      $queryString = str_replace("\r","",$queryString);
      $queryString = str_replace("\n","",$queryString);
      //die($queryString);
      if(strpos("?", $_REQUEST['back_url']) == false)
        $_REQUEST['back_url'] .= '?';
      header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
      header("Cache-Control: no-store, no-cache, must-revalidate");
      header("Cache-Control: post-check=0, pre-check=0", false);
      // HTTP/1.0
      header("Pragma: no-cache");
      header("Location: ".$_REQUEST['back_url'].$queryString);
      exit;
    }
    else
    {
      if(save_comment($Blog, $ID,$data))
      {
        $post = $Blog->getSinglePost($ID);
        if(!strpos($data['url'], "http://")) $data['url'] = "http://".$data['url'];
        writeLog($db, "Comment added to story #$ID - '".$post['title']."'");
        $msg = 'New comment has been added to your story #'.$ID." - '".$post['title']."'. Author: ".$data['guest'].', email: '.$data['email'].', url='.$data['url']."\r\n".$data['comment'];
        if($Blog->settings['notify_comments'] == '1')
        {
          if(!empty($post['author_id']))
          {
            //1. Get email address associated with the author of this post
            $author = $Blog->getAuthor($post['author_id']);
            if(!empty($author['email']))
            {
              $tmp = explode("/", str_replace("http://","",$Blog->settings['site_url']));
              $emailFrom = 'wordsmith@'.$tmp[0];
              $emailMsg  = '<html><body>'.stripslashes($msg).'</body></html>';
              $emailSubj = "New comment added to your post '".$post['title']."'";
              $emailHeaders  = "MIME-Version: 1.0\r\n";
              $emailHeaders .= "Content-type: text/html; charset=UTF-8\r\n";
              $emailHeaders .= "From: ".$emailFrom;
              if(!@mail($author['email'], $emailSubj, $emailMsg, $emailHeaders))
              {
                writeLog($db, "Could not email notification about a new comment to post #".$post['id']." - '".$post['title']."'.");
              }
              else
              {
                writeLog($db, "Successfully emailed a notification about a new comment to post #".$post['id']." - '".$post['title']."' to ".$author['first_name'].' '.$author['last_name']."'s address ".$author['email']);
              }
            }
            else
              writeLog($db, "Could not email notification about a new comment to post #".$post['id']." - '".$post['title']."': ".$author['first_name'].' '.$author['last_name'].' does not have his email address registered with '.$Blog->settings['site_name']);
          }
          else
            writeLog($db, "Could not email notification about a new comment to post #".$post['id'].". Could not find the damn post.");
        }
        cache_single($Blog,$ID,'./');
        cache_main($Blog,$ID);
        header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
        header("Cache-Control: no-store, no-cache, must-revalidate");
        header("Cache-Control: post-check=0, pre-check=0", false);
        // HTTP/1.0
        header("Pragma: no-cache");
        header("Location: ".$_REQUEST['back_url']);
        exit;
      }
      else
      {
        writeLog($db, "Could not add comment to story #$ID - '".$post['title']."'. Comment: ".$data);
      }

    }
  }
  else
  {
    writeLog($db, "Attempt to add comment to story # $ID - '".$post['title']."' - by banned IP '".$_SERVER['REMOTE_ADDR']."'. Comment: ".$data);
  }
}
else echo "Invalid request.";
?>