<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/
// WORDSMITH index page
include("config.inc.php");
include("startup_db.inc.php"); // we connect do db only when we have to
// if the database isn't available, let's reroute it to an error page
if($_db_unavailable==TRUE)
{
  include('template/db_error.html');
  exit;
}
if($Blog->golive($db) != TRUE)
{
  // something in the db isn't right - probably no tables present
  include('template/db_schema_error.html');
  exit;
}
$Blog->loadBannedIPList();
if($Blog->isBanned($_SERVER['REMOTE_ADDR']) && $Blog->handle_banned=='BAN_ALL')
{
  writeLog($db, "Attempt to view blog by banned IP '".$_SERVER['REMOTE_ADDR']."'");
  die("You have been BANNED!");
}
// publish scheduled posts, auto archive items
publish_scheduled($Blog);
autoArchive($Blog);

// are we searching?
$s = filter_for_search($_REQUEST['s']);

// Uncomment to enable caching of the index page
/*
if(empty($s) && is_file('./archive/index.html') && filemtime('./archive/index.html') > filemtime('template/index.html') && (filesize('./archive/index.html') > 0))
{
  // show it and exit if there actually is a cached file AND the template hasn't been changed since
  header("Content-type: text/html; charset=UTF-8");
  include('./archive/index.html');
  exit;
}
*/

$tpl = new WTemplate;
$tpl->debug=false;
$tpl->setPath('template');
$tpl->setExtension('html');
$tpl->init('index');

$search_error=0;
$current_path = '';

/* this SELECT element controls how many records will be fetched when searching posts on the index page */
$recPerPagePL = new Select('n');
$recPerPagePL->addOption(15,15);
$recPerPagePL->addOption(30,30);
$recPerPagePL->addOption(45,45);
$recPerPagePL->selected = $_REQUEST['n'];

// Proceed
if(!empty($_REQUEST['s']))
{
  $searchTerm = unhtmlall(trimall($_REQUEST['s']));
  // search only Published or Archived stories!
  if((empty($_REQUEST['n']) || !is_numeric($_REQUEST['n'])))
    $recPerPage = 15;
  else
    $recPerPage = $_REQUEST['n'];
  if((empty($_REQUEST['p']) || !is_numeric($_REQUEST['p'])))
    $searchPage = 1;
  else
    $searchPage = $_REQUEST['p'];
  $postRecordset = $Blog->search(array('kw'=>$searchTerm, 'title'=>'*'.$searchTerm, 'status'=>array(2,4)), $searchPage, $recPerPage, TRUE);
  if(!empty($postRecordset))
  {
    $post_arr = $postRecordset->getall();
    for($i=0;$i<count($post_arr);$i++)
    {
      $post_arr[$i]['story'] = strip_tags($post_arr[$i]['story']);
      $post_arr[$i]['story'] = preg_replace('/'.$s.'/i','<span class="highlight">\\0</span>',$post_arr[$i]['story']);
      $post_arr[$i]['story'] = substr($post_arr[$i]['story'],0,400) . '...<br/> <a href="'.$Blog->settings['site_url'].'/archive/'.$post_arr[$i]['id'].$Blog->settings['archive_post_ext'].'" title="read on..."><b>Continue reading <i>'.$post_arr[$i]['title'].'</i></b></a>';
      $post_arr[$i]['extended_story'] = false; // just that the "Continue reading ..." text does not appear
    }
    $pagesTotal = ceil($postRecordset->MaxRecordCount() / $recPerPage);
    $pgArr=array();
    for($i=1;$i<=$pagesTotal;$i++)
    {
      if($i == $searchPage)
        $pgArr[] = $i;
      else
        $pgArr[] = '<a href="#" onclick="document.forms[\'searchform\'].elements[\'p\'].value='.$i.';document.forms[\'searchform\'].submit(); return false;">'.$i.'</a>';
    }
    $tpl->replace("PAGES", implode(", ", $pgArr));
  }
  else
  {
    $search_error=1;
    $post_arr = $Blog->loadPosts();
    $tpl->replaceSection("PAGING");
  }
}
else
{
  $post_arr = $Blog->loadPosts();
  $tpl->replaceSection("PAGING");
}

$popStories = $Blog->getMostPopularStories(5);
$popSct = '';
foreach($popStories as $pop)
  $popSct .= '<a href="archive/'.$pop['id'].$Blog->settings['archive_post_ext'].'">'.$pop['title'].'</a><br/>';
$tpl->replace("POPULAR_LIST",$popSct);

$post_section = $tpl->cutSection('POST');
$_content='';

$_temp = new Wtemplate;
$headlines = array();

for($i=0;$i<count($post_arr);$i++)
{
  if($i<$Blog->settings['headlines_no'])
  {
    $headlines[] = '<a href="#'.$post_arr[$i]['id'].'">'.($post_arr[$i]['title']).'</a><br/>';
  }
  $more_text = (!empty($post_arr[$i]['extended_story'])) ? '<p><a href="'.$Blog->settings['site_url'].'/archive/'.$post_arr[$i]['id'].$Blog->settings['archive_post_ext'].'">Continue reading "'.$post_arr[$i]['title'].'" ...</a></p>':false;

  $_temp->sTemplate = $post_section;

  if($Blog->settings['allow_comments'] != '1' || $post_arr[$i]['allow_comments'] != '1')
    $_temp->replaceSection("COMMENTS");

  if($Blog->settings['allow_pings'] != '1' || $post_arr[$i]['allow_pings'] != '1')
    $_temp->replaceSection("TRACKBACKS");

  $storyTopics = $Blog->listStoryTopics($post_arr[$i]['id']);
  if($Blog->settings['use_topics'] == '1' && !empty($storyTopics))
  {
    $topix = array();
    while(list(, $topNAME)=each($storyTopics))
      $topix[] = '<a href="archive/'.tweakFilename($topNAME).$Blog->settings['archive_post_ext'].'">'.$topNAME.'</a>';
    $_temp->replace("STORY_TOPICS",implode(", ", $topix));
  }
  else
  {
    $_temp->replaceSection("POSTCAT");
  }

  $storyRefList = $Blog->listStoryReferences($post_arr[$i]['id']);
  if(!empty($storyRefList))
  {
    $_reflst = '';
    foreach($storyRefList AS $row)
      $_reflst .= '<a href="'.$row['reference_url'].'" target="_blank"/>'.$row['reference_title'].'</a><br/>';
    $_temp->replace("REF_LST",$_reflst);
  }
  else
    $_temp->replaceSection("STORY_REF_LST");

  $date_created_formatted[$i] = adodb_date2('l, F j, Y', $post_arr[$i]['created_on']);
  $date_updated_formatted[$i] = adodb_date2($Blog->settings['date_format'].', G:i', $post_arr[$i]['updated_on']);
 
  if($date_created_formatted[$i] == $date_created_formatted[($i-1)])
    $_temp->replaceSection("POSTDATEH");
  $_temp->replace(
    array(
      'ID'=>$post_arr[$i]['id'],
      'POSTDATE'=>$date_created_formatted[$i],
      'POSTDATE_MON'=>adodb_date2('M', $post_arr[$i]['created_on']),
      'POSTDATE_DW'=>adodb_date2('j', $post_arr[$i]['created_on']),
      'UP_DATE'=>$date_updated_formatted[$i],
      'POSTTITLE'=>$post_arr[$i]['title'],
      'POSTCONTENT'=>$post_arr[$i]['story'].$more_text,
      'AUTHORNAME'=>$post_arr[$i]['first_name'].'&nbsp;'.$post_arr[$i]['last_name'],
      'COMMENTS_CNT'=>$Blog->getCommentCntForPost($post_arr[$i]['id']),
      'TBACK_CNT'=>$Blog->getTBackCntForPost($post_arr[$i]['id'])
    )  
  );
  $_content .= $_temp->out();
}

if($Blog->settings['use_syndication'] != '1')
{
  $tpl->replaceSection("SYNDICATION");
  $tpl->replaceSection("SYNDICATION_LINKS");
}

if(empty($search_error))
  $tpl->replaceSection("SEARCH_ERROR");

$tpl->replaceSection("POST",$_content);

$tpl->replace(
  array(
    'PATH'=>$current_path,
    'SITE_URL'=>$Blog->settings['site_url'],
    'SITE_NAME'=>$Blog->settings['site_name'],
    'SITE_DESC'=>$Blog->settings['site_desc'],
    'SITE_KEYWORDS'=>$Blog->settings['site_keywords'],
    'SEARCH_TERM'=>$s,
    'RECENT'=>(implode("\n",$headlines)),
    'BLOGROLL'=>show_blogroll($Blog),
    'ARCHIVES'=>show_archives($Blog,$Blog->monthly_archives()),
    'PP_PICKLIST'=>$recPerPagePL->show()
    )  
  );

/* Write to cache - uncomment if you're using a cached index page
if(empty($s) && !empty($post_arr))
{
  $fp = @fopen('./archive/index.html','w');
  if(is_resource($fp))
  {
    fwrite($fp,$tpl->out());
    fclose($fp);
  }
}
*/
// Done, do output
header("Content-type: text/html; charset=UTF-8");
echo $tpl->out();
?>