<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

Class Blog {
  
  // class vars
  var $db; // ADODB object
  var $site_url;
  var $site_name;
  var $settings;
  var $_live;

  function Blog($dbobj=false)
  {
    if(is_object($dbobj))
      $this->golive($dbobj);
    else
      $this->_live = false;
  }

  function golive($dbobj)
  {
    $this->_live = false;
    if(is_object($dbobj))
    {
      $this->db = $dbobj;
      $this->_live = $this->loadSettings();
    }
    return $this->_live;
  }
  
  function isLive()
  {
    return $this->_live;
  }

  function loadSettings()
  {
    $sql = "SELECT * FROM cs_settings";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return false;
    $set = $res->getarray();
    foreach($set as $s)
    {
      $this->settings[$s['param_name']] = $s['param_value'];
    }
    $this->site_url = $this->settings['site_url']; // just for convenience
    $this->site_name = $this->settings['site_name']; // the same
    return true;
  }
  
  function clearSettings($s=false)
  {
    $sql = "DELETE FROM cs_settings";
    if(!empty($s))
      $sql .= " WHERE param_name='".$s."'";
    return $this->db->execute($sql);
  }

  function saveSettings($settings)
  {
    if(!is_array($settings)) return false;
    reset($settings);
    while(list($key,$val)=each($settings))
    {
      $sql = "INSERT INTO cs_settings(param_name,param_value) VALUES('".$key."','".$val."')";
      $sql = str_replace("''","NULL",$sql);
      if(!$this->db->execute($sql))
      {
        $sql = "UPDATE cs_settings SET param_value='".$val."' WHERE param_name='".$key."'";
        $this->db->execute($sql);
      }
    }
  }

  function post($arr)
  {
    $arr['abstract'] = strip_tags($arr['story']) . strip_tags($arr['extended_story']);
    $authorData = $this->getAuthor($arr['author_id']);
    if(empty($arr['id']))
    {
     $sql = "INSERT INTO cs_story(author_id,title,abstract,story,extended_story,status,scheduled_for_date,allow_comments,allow_pings,created_on,updated_on) VALUES(".$arr['author_id'].",'".$arr['title']."','".$arr['abstract']."','".$arr['story']."','".$arr['extended_story']. "'," .$arr['status'].",'".$arr['scheduled_for_date']."','".$arr['allow_comments']."','". $arr['allow_pings']."', now(), now())";
    }
    else
    {
      // updating only columns that need updating
      $updateCols = array('title', 'abstract', 'story', 'extended_story', 'updated_on', 'status', 'scheduled_for_date', 'allow_comments', 'allow_pings');
      $sql = "UPDATE cs_story SET ";
      reset($arr);
      while(list($col, $val) = each($arr))
      {
        if(in_array($col,$updateCols))
        {
          $val = "'".$val."'";
          $sql .= $col."=".$val.", ";
        }
      }

      $sql .= " updated_on=now() WHERE id=".$arr['id'];
    }
	  $sql = str_replace(",'',",",NULL,",$sql);
    if($this->db->execute($sql))
    {
      if(empty($arr['id']))
        $ID = $this->db->insert_ID();
      else
        $ID = $arr['id'];
      if(!empty($arr['ref']))
        $this->addStoryReference($ID,$arr);
      if(empty($arr['topic']) || !is_array($arr['topic']))
        $arr['topic'] = array();
      $this->addStoryTopic($ID,$arr['topic']);
      return $ID;
    }
    else return false;
  }
  
  function publish($story_id)
  {
    $sql = "UPDATE cs_story SET status=2 WHERE id=".$story_id;
    return $this->db->execute($sql);
  }

  function archiveStory($story_id)
  {
    $sql = "UPDATE cs_story SET status=4 WHERE id=".$story_id;
    return $this->db->execute($sql);
  }

  function addStoryReference($storyID, $storyData)
  {
    if(!is_array($storyData['ref']))
      return false;
    foreach($storyData['ref'] as $ref)
    {
      $sql = "INSERT INTO cs_story_reference(story_id, reference_title, reference_url, reference_ping, created_on) VALUES(".$storyID.",'". $ref['title']."', '". $ref['link']."','". $ref['ping']."',now())";
      $this->db->execute($sql);
      $rowID = $this->db->insert_ID();
      if(!empty($ref['do_ping']))
      {
        $url = $ref['ping'];
        $title = $storyData['title'];
        $excerpt = substr(strip_tags($storyData['story']),0,252) . '...';
        $this->trackback($url, $title, $excerpt, $storyID); // FIXME: don't take it for granted! :)
        $sql = "UPDATE cs_story_reference SET pinged_on=now() WHERE rowid=".$rowID;
        $this->db->execute($sql);
      }
    }
  }

  function listStoryReferences($story_id)
  {
    $sql = "SELECT * FROM cs_story_reference WHERE story_id = ".$story_id;
    $res = $this->db->execute($sql);
    if(is_object($res))
      return $res->getArray();
    else
      return false;
  }

  function is_current($post_id)
  {
    $sql = "SELECT id FROM cs_story WHERE id='".$post_id."' AND (TO_DAYS(NOW()) - TO_DAYS(created_on) <= '".$this->settings['days_per_page']."')";
    $res = $this->db->execute($sql);
    if(!empty($res->fields['id']))
      return true;
    return false;
  }

  function parseOpAndDate($str)
  {
    // parse operator
    $res=array();
    $ops = array('<','>','=','!');
    for($i=0;$i<strlen($str);$i++)
    {
      if(in_array($str[$i],$ops))
      {
        $res[0]  .= $str[$i];
      }
      else
      {
        if($str[$i] != ' ')
          $res[1] .= $str[$i];
      }
    }
    return $res;
  }

  function normalizeDateString($date_string)
  {
    /* we have to fix MySQL bug that doesn't allow searching using German date format (d.m.Y)
    */
    if(strpos($date_string, ".") != false) // German format
      $date_string = implode("-",array_reverse(explode(".",$date_string)));
    else if(strpos($date_string, " ") != false) //assuming ISO format
      $date_string = implode("-",explode(" ",$date_string));
    else if(strpos($date_string, "/") != false) // assuming American format m/d/Y
    {
      $tmp = explode("/",$date_string);
      $date_string = $tmp[2].'-'.$tmp[0].'-'.$tmp[1];
    }
    return $date_string;
  }

  function search($s,$page=1,$nrows=10,$publicSearch=false)
  {
    // convert * to %
    $s['kw'] = str_replace("*","%",$s['kw']);
    $s['title'] = str_replace("*","%",$s['title']);

    $sql = "SELECT a.id, a.author_id, a.title, a.story, a.extended_story, a.status, a.created_on, ast.status AS status_name, b.first_name, b.last_name, COUNT(c.id) AS comments, COUNT(d.id) AS trackbacks FROM cs_story AS a LEFT OUTER JOIN cs_comment AS c ON (c.story_id=a.id) LEFT OUTER JOIN cs_trackback AS d ON (d.story_id=a.id), cs_story_status AS ast, cs_author AS b WHERE (b.id=a.author_id AND ast.id=a.status)";
    if($publicSearch == true)
    {
      // when readers search for posts using the form on the index page, they want posts containing the search term either in the title or within the post text
      $sql .= " AND (a.abstract LIKE '%".$s['kw']."%' OR a.title LIKE '%".$s['title']."%')";
    }
    else
    {
      if(!empty($s['kw']))
        $sql .= " AND a.abstract LIKE '%".$s['kw']."%'";
      if(!empty($s['title']))
        $sql .= " AND a.title LIKE '".$s['title']."%'";
    }
    if(!empty($s['author']))
      $sql .= " AND b.id='".$s['author']."'";
    if(!empty($s['date']))
    {
      if(ereg("^[0-9]",$s['date']))
      {
        $date_operator = "="; // default operator
        $date_string = $s['date'];
      }
      else
      {
        list($date_operator, $date_string) = $this->parseOpAndDate($s['date']);
      }

      $date_string = $this->normalizeDateString($date_string);
      if(strlen($date_string) >=2 && strlen($date_string) < 5)
        $sql .= " AND YEAR(a.created_on)".$date_operator."'".$date_string."'"; // searching for YEAR
      else if(strlen($date_string) > 4 && strlen($date_string) < 8)
      { // searching for YEAR and MONTH
        list($date_year, $date_month) = explode("-", $date_string);
        $sql .= " AND YEAR(a.created_on)".$date_operator."'".$date_year."' AND MONTH(a.created_on)".$date_operator."'".$date_month."'";
      }
      else
      { // searching for full date
        // if operator == '=', we must tweak it a little because the datatype is datetime
        if($date_operator == '=')
        {
          $sql .= " AND a.created_on >= '".$date_string." 00:00:00' AND a.created_on <= '".$date_string." 23:59:59'";
        }
        else
          $sql .= " AND a.created_on ".$date_operator."'".$date_string."'";
      }
    }
    if(!empty($s['scheduled_for_date']))
    {
      if(ereg("^[0-9]",$s['scheduled_for_date']))
      {
        $date_operator = "="; // default operator
        $date_string = $s['scheduled_for_date'];
      }
      else
      {
        list($date_operator, $date_string) = $this->parseOpAndDate($s['scheduled_for_date']);
      }
      // we have to fix MySQL bug that doesn't allow searching using German date format (d.m.Y)
      if(strpos($date_string, ".") != false)
        $date_string = implode("-",array_reverse(explode(".",$date_string)));

      $sql .= " AND a.scheduled_for_date ".$date_operator."'".$date_string."'";
    }
    
    if(is_array($s['status']))
      $sql .= " AND a.status IN(".implode(",",$s['status']).")";
    else if(strlen($s['status']) >= 1) // workaround hack because empty(0) = true
      $sql .= " AND a.status=".$s['status'];
    
    if(strpos($this->db->databaseType, 'postgres') !== false)
    {
      $sql .= " GROUP BY a.id, a.author_id, a.title, a.story, a.extended_story, a.status, a.created_on, ast.status, b.first_name, b.last_name";
    }
    else
    {
      $sql .= " GROUP BY a.id";
    }
    if(in_array($s['comments'],array('NULL','NOT NULL')) || in_array($s['trackbacks'],array('NULL','NOT NULL')))
    {
      if(in_array($s['comments'],array('NULL','NOT NULL')))
        $_[] = " comments" . (($s['comments']=='NULL') ? '=0':'>0');
      if(in_array($s['trackbacks'],array('NULL','NOT NULL')))
        $_[] = " trackbacks" . (($s['trackbacks']=='NULL') ? '=0':'>0');
      $sql .= ' HAVING '.implode(" AND ",$_);
    }
    $sql .= " ORDER BY a.created_on DESC";
    $res = $this->db->PageExecute($sql, $nrows, $page);
    if(!is_object($res)) return -1;
    return $res;
  }

  function searchFeedback($type, $filter, $page, $limit)
  {
    if(!is_array($filter)) $filter = array();
    $filter['kw']  = str_replace("*","%",$filter['kw']);
    $filter['title']  = str_replace("*","%",$filter['title']);
    $filter['author'] = str_replace("*","%",$filter['author']);
    $fTbl = ($type=='trackbacks') ? 'cs_trackback':'cs_comment';
    $sql = "SELECT cs_story.title, cs_story.author_id, ".$fTbl.".* FROM cs_story, ".$fTbl. " WHERE cs_story.id=".$fTbl.".story_id";
    if(!empty($filter['kw']))     $sql .= " AND ".$fTbl.".comment LIKE '%".$filter['kw']."%'";
    if(!empty($filter['title']))  $sql .= " AND cs_story.title LIKE '".$filter['title']."%'";
    if(!empty($filter['author'])) $sql .= " AND ".$fTbl.".guest LIKE '".$filter['author']."%'";
    
    if(!empty($filter['date']))
    {
      if(ereg("^[0-9]",$filter['date']))
      {
        $date_operator = "="; // default operator
        $date_string = $filter['date'];
      }
      else
      {
        list($date_operator, $date_string) = $this->parseOpAndDate($filter['date']);
      }

      $date_string = $this->normalizeDateString($date_string);
      if(strlen($date_string) >=2 && strlen($date_string) < 5)
        $sql .= " AND YEAR(".$fTbl.".created_on)".$date_operator."'".$date_string."'"; // searching for YEAR
      else if(strlen($date_string) > 4 && strlen($date_string) < 8)
      { // searching for YEAR and MONTH
        list($date_year, $date_month) = explode("-", $date_string);
        $sql .= " AND YEAR(".$fTbl.".created_on)".$date_operator."'".$date_year."' AND MONTH(".$fTbl.".created_on)".$date_operator."'".$date_month."'";
      }
      else
      { // searching for full date
        // if operator == '=', we must tweak it a little because the datatype is datetime
        if($date_operator == '=')
        {
          $sql .= " AND ".$fTbl.".created_on >= '".$date_string." 00:00:00' AND ".$fTbl.".created_on <= '".$date_string." 23:59:59'";
        }
        else
          $sql .= " AND ".$fTbl.".created_on ".$date_operator."'".$date_string."'";
      }
    }

    $sql .= " ORDER BY ".$fTbl.".created_on DESC";

    $res = $this->db->PageExecute($sql, $limit, $page);
    if(!is_object($res)) return -1;
    return $res;
  }

  function loadPosts()
  {
    if(strpos($this->db->databaseType, 'postgres') !== false)
    {
      $sql = "SELECT a.*, b.first_name, b.last_name FROM cs_story AS a, cs_author AS b WHERE ( a.status=2 OR a.status=4 ) AND b.id=a.author_id AND a.created_on >= (CURRENT_DATE - INTERVAL '".$this->settings['days_per_page']." DAYS')";
    }
    else
    {
      $sql = "SELECT a.*, b.first_name, b.last_name FROM cs_story AS a, cs_author AS b WHERE ( a.status=2 OR a.status=4 ) AND b.id=a.author_id AND (TO_DAYS(NOW()) - TO_DAYS(a.created_on) <= '".$this->settings['days_per_page']."') ORDER BY a.created_on DESC";
    }
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    return $res->getArray();
  }

  function getSinglePost($id)
  {
    $sql = "SELECT a.*, b.first_name, b.last_name FROM cs_story AS a, cs_author AS b WHERE b.id=a.author_id AND a.id='".$id."'";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    return $res->fields;
  }

  function getPostsForMonth($month,$year)
  {
    $sql = "SELECT a.*, b.first_name, b.last_name FROM cs_story AS a, cs_author AS b WHERE b.id=a.author_id AND";
    if(strpos($this->db->databaseType, 'postgres') !== false)
    {
      $sql .= " date_part('month', a.created_on)='".$month."' AND date_part('year', a.created_on)='".$year."'";
    }
    else
    {
      $sql .= " MONTH(a.created_on) = '".$month."' AND YEAR(a.created_on) = '".$year."'";
    }
    $sql .= " AND ( status=2 OR status=4 ) ORDER BY a.created_on DESC";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    return $res->getArray();
  }

  function getPostsForTopic($topicID=false)
  {
    $list = array();
    $sql = "SELECT cs_story.*, cs_story_topics.topic_id, cs_author.first_name, cs_author.last_name FROM cs_story, cs_story_topics, cs_author WHERE cs_story.id=cs_story_topics.story_id AND cs_author.id=cs_story.author_id AND (cs_story.status=2 OR cs_story.status=4)";
    if(!empty($topicID))
      $sql .= " AND cs_story_topics.topic_id=".$topicID;
    $sql .= " ORDER BY cs_story.created_on DESC";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    $tmp = $res->getArray();
    foreach($tmp AS $row)
      $list[$row['topic_id']][] = $row;
    return $list;
}

  function getViewsPerPost($id, $standaloneOnly=false)
  {
    $sql = "SELECT COUNT(rowid) AS cnt FROM cs_tracker WHERE story_id IS NOT NULL AND story_id='".$id."'";
    if($standaloneOnly)
      $sql .= " AND page NOT LIKE '%index%'";
    $res = $this->db->execute($sql);
    if(is_object($res))
      return $res->fields['cnt'];
    else
      return -1;
  }

  function getCommentCntForPost($id)
  {
    $sql = "SELECT COUNT(*) AS cnt FROM cs_comment WHERE story_id='".$id."'";
    $res = $this->db->execute($sql);
    return $res->fields['cnt'];
  }

  function getTBackCntForPost($id)
  {
    $sql = "SELECT COUNT(*) AS cnt FROM cs_trackback WHERE story_id='".$id."'";
    $res = $this->db->execute($sql);
    return $res->fields['cnt'];
  }

  function listCommentsForPost($id)
  {
    $sql = "SELECT * FROM cs_comment WHERE story_id='".$id."' ORDER BY created_on";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    return $res->getArray();
  }
  
  function listTBacksForPost($id)
  {
    $sql = "SELECT * FROM cs_trackback WHERE story_id='".$id."' ORDER BY created_on";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    return $res->getArray();
  }

  function addCommentToPost($id,$postArr)
  {
    $sql = "INSERT INTO cs_comment(story_id,created_on,guest,email,url,comment,ip,country) VALUES(".$id.",now(),'".
            $postArr['guest']."','".$postArr['email']."','".$postArr['url']."','".$postArr['comment']."','". $postArr['ip']."','".$postArr['country']."')";
    $sql = str_replace("''","NULL",$sql);
    return $this->db->execute($sql);
  }

  function editComment($id, $content)
  {
    $sql = "UPDATE cs_comment SET comment = '".$content."' WHERE id=".$id;
    $sql  = str_replace("''","NULL",$sql);
    return $this->db->execute($sql);
  }

  function deleteComment($id)
  {
    $sql = "DELETE FROM cs_comment WHERE id=".$id;
    $sql  = str_replace("''","NULL",$sql);
    return $this->db->execute($sql);
  }

  function addTrackBackToPost($story_id,$url,$blogname,$title,$excerpt)
  {
    $sql = "INSERT INTO cs_trackback(story_id,url,remote_blog,title,comment,created_on) VALUES(".$story_id.
           ",'".$url."','".$blogname."','".$title."','".$excerpt."',now())";
    return $this->db->execute($sql);
  }

  function editTrackback($id, $content)
  {
    $sql = "UPDATE cs_trackback SET comment = '".$content."' WHERE id=".$id;
    $sql  = str_replace("''","NULL",$sql);
    return $this->db->execute($sql);
  }

  function deleteTrackback($id)
  {
    $sql = "DELETE FROM cs_trackback WHERE id=".$id;
    $sql  = str_replace("''","NULL",$sql);
    return $this->db->execute($sql);
  }

  function massDeleteFeedback($type, $arrId, $alsoBanIPs=false, $pathToGEOlib=false)
  {
    if(empty($type) || !is_array($arrId))
      return false;
    $fnc = ($type == 'comments') ? 'deleteComment':'deleteTrackback';
    foreach($arrId AS $id)
    {
      $sql = "SELECT ip FROM cs_comment WHERE id='".$id."'";
      $res = $this->db->execute($sql);
      if($alsoBanIPs != false && !empty($res->fields['ip']))
        $this->banIP($res->fields['ip'], $this->getCountryFromIp($pathToGEOlib, $res->fields['ip']));
      $this->$fnc($id);
    }
  }

  function listStoryStatus()
  {
    $sql = "SELECT * FROM cs_story_status ORDER BY id";
    $res = $this->db->execute($sql);
    $stats=array();
    if(!is_object($res)) return -1;
    while(!$res->EOF)
    {
      $stats[$res->fields['id']] = $res->fields['status'];
      $res->MoveNext();
    }
    return $stats;
  }

  function addTopic($topic)
  {
    $sql = "INSERT INTO cs_topics(topic) VALUES('".$topic."')";
    $sql = str_replace("''","NULL",$sql);
    $res = $this->db->execute($sql);
    if(is_object($res))
      return $this->db->insert_ID();
    else
      return false;
  }

  function addStoryTopic($storyID, $topics)
  {
    $sql = "DELETE FROM cs_story_topics WHERE story_id=".$storyID;
    $this->db->execute($sql);
    foreach($topics as $topicID)
    {
      $sql = "INSERT INTO cs_story_topics(story_id, topic_id) VALUES(".$storyID.", ".$topicID.")";
      $this->db->execute($sql);
    }
  }

  function listTopics()
  {
    $sql = "SELECT * FROM cs_topics ORDER BY topic";
    $res = $this->db->execute($sql);
    if(is_object($res))
    {
      $pairs = array();
      while(!$res->EOF)
      {
        $pairs[$res->fields['id']] = $res->fields['topic'];
        $res->movenext();
      }
    }
    return $pairs;
  }

  function listStoryTopics($storyID)
  {
    $pairs = array();
    $sql = "SELECT cs_topics.id, cs_topics.topic FROM cs_topics, cs_story_topics WHERE cs_topics.id=cs_story_topics.topic_id AND cs_story_topics.story_id=".$storyID;
    $res = $this->db->execute($sql);
    if(is_object($res))
    {
      while(!$res->EOF)
      {
        $pairs[$res->fields['id']] = $res->fields['topic'];
        $res->movenext();
      }
    }
    return $pairs;
  }

  function list_bookmarks($status=false,$cat_id=false, $is_syndicated=false)
  {
    // OBSOLETE
    $sql = "SELECT * FROM cs_neighborhood";
    if(strlen($status) == 1)
      $wh[] = " active=".$status; // either 1 or 0
    if($cat_id != false)
      $wh[] = " cat_id='".$cat_id."'";
    if($is_syndicated == 1)
      $wh[] = " rss_file IS NOT NULL";
    else if($is_syndicated == 0 && strlen($is_syndicated) == 1)
      $wh[] = " rss_file IS NULL";
    if(!empty($wh))
      $sql .= " WHERE ".implode(" AND ", $wh);
    $sql .= ' ORDER BY short_name';
    $res = $this->db->execute($sql);
    if(!is_object($res)) return false;
    while(!$res->EOF)
    {
      $list[$res->fields['id']] = $res->fields;
      $res->MoveNext();
    }
    return $list;
  }

  function listBookmarksForCategory($statusId, $categoryId)
  {
    $sql = "SELECT * FROM cs_neighborhood WHERE 1";
    if(strlen($statusId) == 1)
      $sql .= " AND active=".$statusId; // either 1 or 0
    if($categoryId != false)
      $sql .= " AND cat_id='".$categoryId."'";
    $sql .= ' ORDER BY short_name';
    $res = $this->db->execute($sql);
    if(!is_object($res)) return false;
    return $res->getall();
  }


  function listBookmarkCats()
  {
    $sql = "SELECT a.id, a.category, a.rank, COUNT(b.id) AS bookmarks FROM cs_linkscat as a LEFT JOIN cs_neighborhood AS b ON(b.cat_id=a.id) GROUP BY a.id, a.category, a.rank ORDER BY a.rank";
    $res = $this->db->execute($sql);
    if(is_object($res))
      return $res->getall();
    return false;
  }

  function addBookmarkCat($cat,$rank)
  {
    $sql = "INSERT INTO cs_linkscat(category, rank) VALUES('".trim($cat)."',".$rank.")";
    $res = $this->db->execute($sql);
    if(!empty($res))
      return $this->db->insert_ID();
    else
      return false;
  }
  
  function modifyBookmarkCat($id, $cat, $rank)
  {
    $sql = "UPDATE cs_linkscat SET category='".$cat."', rank=".$rank." WHERE id=".$id;
    return $this->db->execute($sql);
  }

  function removeBookmarkCat($id)
  {
    $sql = "DELETE FROM cs_linkscat WHERE id=".$id;
    return $this->db->execute($sql);
  }

  function manage_bookmark($b)
  {
    if(!eregi("^http:\/\/",$b['uri']))
      $b['uri'] = 'http://'.$b['uri'];
    if(!empty($b['rss_file']) && !eregi("^http:\/\/",$b['rss_file']))
      $b['rss_file'] = 'http://'.$b['rss_file'];
    if(empty($b['id']))
      $sql = "INSERT INTO cs_neighborhood(uri,cat_id,short_name,long_name,rss_file,created_on) VALUES('".$b['uri']."','".$b['cat_id']."','".$b['short_name']."','".$b['long_name']."','".$b['rss_file']."',now())";
    else
      $sql = "UPDATE cs_neighborhood SET cat_id='".$b['cat_id']."', short_name='".$b['short_name']."', long_name='".$b['long_name']."', uri='".$b['uri']."', rss_file='".$b['rss_file']."' WHERE id=".$b['id'];
    $sql = str_replace("''","NULL",$sql);
    return $this->db->execute($sql);
}

  function toggleBookmarkStatus($bID)
  {
    if(!empty($bID))
    {
      $sql = "SELECT active FROM cs_neighborhood WHERE id='".$bID."'";
      $res = $this->db->execute($sql);
      if($res->fields['active']=='1')
        $new_stat=0;
      else
        $new_stat=1;
      $sql = "UPDATE cs_neighborhood SET active=".$new_stat." WHERE id='".$bID."'";
      return $this->db->execute($sql);
    }
  }

  function syndicate($type,$path='../',$all=false)
  {
    if(!in_array($type,array('rss','rdf')))
      return false;

    $tpl = new WTemplate;
    $tpl->setPath($path.'template');
    $tpl->setExtension('xml');
    $tpl->init($type);
    $section1 = $tpl->cutSection("ARTICLE_LIST");
    $section2 = $tpl->cutSection("ARTICLE_ITEMS");
    $article_list = $stories='';
    $sec1 = $sec2 = new WTemplate;
    $sql = "SELECT a.*, b.last_name, b.first_name, c.status FROM cs_story AS a, cs_author AS b, cs_story_status  AS c WHERE (a.status=2 OR a.status=4) AND b.id=a.author_id AND c.id=a.status ORDER BY a.created_on DESC";
    if(!empty($this->settings['days_per_syndication']) && $all===false)
      $sql .= " LIMIT ".$this->settings['days_per_syndication'];
    $res = $this->db->execute($sql);
    while(!$res->EOF)
    {
      $arr = $res->fields;
      //$arr['story'] = str_replace("'",'&#039;',$arr['story']);
      //$arr['story'] = str_replace('"','&quot;',$arr['story']);

      if($type=='rdf')
      {
        $sec1->sTemplate = $section1;
        $sec1->replace("PERMALINK_SINGLE",($this->settings['site_url'].'/archive/'.$arr['id'].'.html'));
        $article_list .= $sec1->out();
      }
      $sec2->sTemplate = $section2;
      $sec2->replace(
        array(
          'POSTTITLE'=>$arr['title'],
          'POSTCONTENT'=>firstwords($arr['abstract'],80).' ...',
          'PERMALINK'=>($this->settings['site_url'].'/archive/'.$arr['id'].'.html'),
          'POSTDATE'=>$arr['created_on'],
          'AUTHORNAME'=>($arr['first_name'].' '.$arr['last_name']),
          'KEYWORDS'=>'',
          'POSTCONTENT_HTML'=>$arr['story']
        )  
      );
      $stories .= $sec2->out();
      $res->movenext();
    }
    $tpl->replaceSection("ARTICLE_LIST",$article_list);
    $tpl->replaceSection("ARTICLE_ITEMS",$stories);
    $tpl->replace(
      array(
        'SITE_NAME'=>$this->settings['site_name'],
        'SITE_URL'=>$this->settings['site_url'],
        'TAGLINE'=>$this->settings['tagline'],
        'BUILDDATE'=>gmdate("D, d M Y H:i:s")
      )  
    );

    return $tpl->out();
  }

  function monthly_archives()
  {
    if(strpos($this->db->databaseType, 'postgres') !== false)
    {
      $sql = "SELECT DISTINCT DATE_PART('year', created_on) AS archive_year, DATE_PART('month', created_on) AS archive_month FROM cs_story ORDER BY archive_year DESC, archive_month DESC";
    }
    else
    {
      $sql = "SELECT DISTINCT YEAR(created_on) AS archive_year, MONTH(created_on) AS archive_month FROM cs_story ORDER BY created_on DESC";
    }
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    $arr = ($res->getArray());
    for($i=0;$i<count($arr);$i++)
    {
      $arr[$i]['month_name'] = date('F', strtotime($arr[$i]['archive_year'].'-'.$arr[$i]['archive_month']));
    }
    return $arr;
  }

  function trackback($trackback_url, $title, $excerpt, $my_story_id)
  {
    $title = ($title);
    $excerpt = (stripslashes($excerpt));
    $blog_name = ($this->settings['site_name']);
    $url = ($this->settings['site_url'].'/archive/'.$my_story_id.'.html');
    $tmp = explode("?",$trackback_url);
    $host = $tmp[0];
    $queryString = $tmp[1]."&title=$title&url=$url&blog_name=$blog_name&excerpt=$excerpt";
    $connData = array('target_url'=>$host, 'target_method'=>'POST');
    return httpSend($queryString, $connData);
  }


  function getAuthor($id=false)
  {
    $sql = "SELECT * FROM cs_author";
    if(!empty($id)) $sql.=" WHERE id='".$id."'";
    $sql .= " ORDER BY last_name";
    $res = $this->db->execute($sql);
    if(!is_object($res)) return -1;
    $arr = $res->getarray();
    if(!empty($id))
      return $arr[0];
    else
      return $arr;
  }

  function getAuthorPostsTotal($id)
  {
    $sql = "SELECT COUNT(*) AS cnt FROM cs_story WHERE author_id='".$id."'";
    $res = $this->db->execute($sql);
    return $res->fields['cnt'];
  }

  function manageAuthor($arr)
  {
    $arr['bio'] = addslashes(stripslashes($arr['bio']));
    if(!empty($arr['id']))
    {
      $sql = "UPDATE cs_author SET first_name='".$arr['first_name']."', last_name='".$arr['last_name']. "', email='".$arr['email']."', city='".$arr['city']."', country='".$arr['country']."', timezone='".$arr['timezone']."', login='".$arr['loginname']."', is_admin='".$arr['is_admin']."' WHERE id='".$arr['id']."'";
      $sql = str_replace("''","NULL",$sql);
      $res = $this->db->execute($sql);
      return $arr['id'];
    }
    else
    {
      $sql = "INSERT INTO cs_author(first_name,last_name,email, city, country, timezone, login, created_on) VALUES('".$arr['first_name']."', '".$arr['last_name']."', '".$arr['email']."', '".$arr['city']."', '".$arr['country']."', '".$arr['timezone']."', '".$arr['loginname']."',now())";
      $sql = str_replace("''","NULL",$sql);
      $res = $this->db->execute($sql);
      return $this->db->insert_ID();
    } 
  }

  function changeAuthorPassword($id,$pwd)
  {
    $new_pwd = md5($pwd);
    $sql = "UPDATE cs_author SET passwd='".$new_pwd."' WHERE id='".$id."'";
    return $this->db->execute($sql);
  }

  function removeAuthor($id)
  {
    if($this->getAuthorPostsTotal($id) == 0)
    {
      $sql = "DELETE FROM cs_author WHERE id='".$id."'";
      return $this->db->execute($sql);
    }
    return false;
  }

  function login($name,$pwd)
  {
    $sql = "SELECT * FROM cs_author WHERE login='".$name."' AND passwd='".md5($pwd)."'";
    $res = $this->db->execute($sql);
    if(empty($res->fields['id'])) return false;
    else return $res->fields;
  }

  function getTabularDataSimple($table, $orderByCol='', $order='ASC', $page=false, $limit=false)
  {
    $sql = "SELECT * FROM $table ";
    if(!empty($orderByCol))
      $sql .= " ORDER BY $orderByCol $order";
    if(!empty($page) && !empty($limit))
      return $this->db->pageExecute($sql, $limit, $page);
    else
      return $this->db->execute($sql);
  }

  function loadBannedIPList()
  {
    $sql = "SELECT ip FROM cs_banlist";
    $res = $this->db->execute($sql);
    $this->settings['banned'] = array();
    while(!$res->EOF)
    {
      $this->settings['banned'][] = $res->fields['ip'];
      $res->MoveNext();
    }
    return $this->settings['banned'];
  }

  function isBanned($ip)
  {
    if(!is_array($this->settings['banned']))
      $this->loadBannedIPList();
    return in_array($ip, $this->settings['banned']);
  }
  
  function banIP($ip, $country)
  {
    $sql = "INSERT INTO cs_banlist(ip, country, created_on) VALUES('".$ip."','".$country."',now())";
    return $this->db->execute($sql);
  }

  // Tracker
  function searchTracker($fs, $ft, $limit=false, $page=false)
  {
    $sql = "SELECT cs_story.title, cs_tracker.* FROM cs_tracker LEFT OUTER JOIN cs_story ON(cs_story.id=cs_tracker.story_id) WHERE 1";
    if(is_array($ft))
    {
      reset($ft);
      while(list($key, $val)=each($ft))
        $ft[$key] = str_replace("*","%",$val);
    }
    // fulltext search has priority
    if(!empty($ft['dates']))
    {
      if(ereg("^[0-9]",$ft['dates']))
      {
        $date_operator = "="; // default operator
        $date_string = $ft['dates'];
      }
      else
      {
        list($date_operator, $date_string) = $this->parseOpAndDate($ft['dates']);
      }
      $date_string = $this->normalizeDateString($date_string);
      if(strlen($date_string) >=2 && strlen($date_string) < 5)
        $sql .= " AND YEAR(cs_tracker.created_on)".$date_operator."'".$date_string."'"; // searching for YEAR
      else if(strlen($date_string) > 4 && strlen($date_string) < 8)
      { // searching for YEAR and MONTH
        list($date_year, $date_month) = explode("-", $date_string);
        $sql .= " AND YEAR(cs_tracker.created_on)".$date_operator."'".$date_year."' AND MONTH(cs_tracker.created_on)".$date_operator."'".$date_month."'";
      }
      else
      { // searching for full date
        // if operator == '=', we must tweak it a little because the datatype is datetime, and besides, MySQL sucks
        if($date_operator == '=')
          $sql .= " AND cs_tracker.created_on >= '".$date_string." 00:00:00' AND cs_tracker.created_on <= '".$date_string." 23:59:59'";
        else
          $sql .= " AND cs_tracker.created_on ".$date_operator."'".$date_string."'";
      }
    }
    else if(!empty($fs['dates']))
    {
      switch($fs['dates'])
      {
        case "Today":
          $sql .= " AND cs_tracker.created_on >='".date("Y-m-d")." 00:00:00'";
        break;
        case "This week":
          $sql .= " AND WEEK(cs_tracker.created_on) = WEEK(CURDATE()) AND YEAR(cs_tracker.created_on) = YEAR(CURDATE())";// FIXME: some countries start their week on Sun, others on Mon!
        break;
        case "This month":
          $sql .= " AND MONTH(cs_tracker.created_on) = MONTH(CURDATE()) AND YEAR(cs_tracker.created_on) = YEAR(CURDATE())";
        break;
      }
    }

    if(!empty($ft['country']))
      $sql .= " AND country LIKE '".$ft['country']."%'";
    else if(!empty($fs['country']))
      $sql .= " AND country='".$fs['country']."'";

    if(!empty($ft['page']))
      $sql .= " AND cs_story.title LIKE '".$ft['page']."%' AND cs_tracker.page NOT LIKE '%index%'";

    if(!empty($ft['ip']))
      $sql .= " AND ip LIKE '".$ft['ip']."%'";
    else if(!empty($fs['ip']))
      $sql .= " AND ip='".$fs['ip']."'";

    if(!empty($ft['hostname']))
      $sql .= " AND hostname LIKE '".$ft['hostname']."%'";
    else if(!empty($fs['hostname']))
      $sql .= " AND hostname='".$fs['hostname']."'";

    if(!empty($ft['referer']))
      $sql .= " AND referer LIKE 'http://".$ft['referer']."%'";
    else if(!empty($fs['referer']))
      $sql .= " AND referer='".$fs['referer']."'";

    $sql .= " GROUP BY cs_tracker.created_on ORDER BY cs_tracker.created_on DESC";

    if(!empty($limit) && !empty($page))
      $resultSet = $this->db->PageExecute($sql, $limit, $page);
    else
      $resultSet =  $this->db->execute($sql);
    return $resultSet;
  }

  function getMostPopularStories($limit=10)
  {
    $sql = 'SELECT a.id, a.title, count( b.rowid ) AS views FROM cs_story AS a JOIN cs_tracker AS b ON ( b.story_id = a.id ) WHERE b.page NOT LIKE \'%index%\' GROUP BY a.id, a.title ORDER BY views DESC LIMIT '.$limit;
    $res = $this->db->execute($sql);
    return $res->getAll();
  }

  function noteSave($arr)
  {
    if(!is_array($arr)) return false;
    if(empty($arr['id']))
    {//insert
      $sql = "INSERT INTO cs_scrapbook(author_id, topic_id, note, created_on) VALUES('".$arr['author_id']."','". $arr['topic_id']."','".$arr['note']."',now())";
      if($this->db->execute($sql))
        $ID = $this->db->insert_ID();
      else
        $ID = false;
    }
    else
    {//update
      $sql = "UPDATE cs_scrapbook SET topic_id='".$arr['topic_id']."', note='".$arr['note']."' WHERE id='".$arr['id']."'";
      if($this->db->execute($sql))
        $ID = $arr['id'];
      else
        $ID = false;
    }
    return $ID;
  }

  function noteList($authorID, $page=1, $nrows=10, $filter=array())
  {
    if(!is_numeric($authorID)) return false;
    $sql = "SELECT a.*, b.last_name, b.first_name, c.topic FROM cs_scrapbook AS a, cs_author AS b, cs_topics AS c WHERE a.author_id='".$authorID."' AND b.id=a.author_id AND c.id=a.topic_id";
    if(!empty($filter['kw']))
      $sql .= " AND note LIKE '%".$filter['kw']."%'";
    $sql .= " ORDER BY a.created_on DESC";
    return $this->db->PageExecute($sql, $nrows, $page);
  }

  function noteDelete($noteId, $authorId)
  {
    // one can only delete his own note
    $sql = "DELETE FROM cs_scrapbook WHERE id=".$noteId." AND author_id=".$authorId;
    return $this->db->execute($sql);
  }

  function getCountryFromIp($pathToFile, $ip)
  {
    $gi = geoip_open($pathToFile."GeoIP.dat",GEOIP_STANDARD);
    $country = geoip_country_name_by_addr($gi, $ip);
    return $country;
  }

}
?>