<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             | 
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

/*                           Cache-related functions                         */
function cache_single($Blog,$post_id,$current_path='./', $archive_monthly_too=true)
{
  $tpl = new WTemplate;
  $tpl->debug=false;
  $tpl->setPath($current_path.'template');
  $tpl->setExtension('html');
  $tpl->init('single');

  $post = $Blog->getSinglePost($post_id);

  $storyRefList = $Blog->listStoryReferences($post['id']);
  if(!empty($storyRefList))
  {
    $_reflst = '';
    foreach($storyRefList AS $row)
      $_reflst .= '<a href="'.$row['reference_url'].'" target="_blank"/>'.$row['reference_title'].'</a><br/>';
    $tpl->replace("REF_LST",$_reflst);
  }
  else
    $tpl->replaceSection("STORY_REF_LST");

  $storyTopics = $Blog->listStoryTopics($post['id']);
  if($Blog->settings['use_topics'] == '1' && !empty($storyTopics))
  {
    $topix = array();
    while(list(, $topNAME)=each($storyTopics))
      $topix[] = '<a href="'.$Blog->settings['site_url'].'/archive/'.tweakFilename($topNAME).$Blog->settings['archive_post_ext'].'">'.$topNAME.'</a>';
    $tpl->replace("STORY_TOPICS",implode(", ", $topix));
  }
  else
  {
    $tpl->replaceSection("POSTCAT");
  }

  if($Blog->settings['allow_comments'] != '1' || $post['allow_comments'] != '1')
    $tpl->replaceSection("COMMENTS");
  else
  {
    $comment_arr = $Blog->listCommentsForPost($post_id);
    $cmmt_section = $tpl->cutSection('COMMENT');
    $_content='';
    $_temp = new Wtemplate;
    for($i=0;$i<count($comment_arr);$i++)
    {
      $comment_arr[$i]['created_on'] = adodb_date2($Blog->settings['date_format'].', G:i',$comment_arr[$i]['created_on']);
      if(!empty($comment_arr[$i]['url']))
      {
        $comment_arr[$i]['guest'] = '<a href="'.$comment_arr[$i]['url'].'" target="_blank">'.$comment_arr[$i]['guest'].'</a>';
      }
      $_temp->sTemplate = $cmmt_section;
      $_temp->replace(
      array(
        'COMMENTCONTENT'=>$comment_arr[$i]['comment'],
        'GUEST'=>$comment_arr[$i]['guest'],
        'COMMENTDATE'=>$comment_arr[$i]['created_on']
      )
      );
      $_content .= $_temp->out();
    }
    if(!empty($_content))
      $tpl->replaceSection("NO_COMMENT");
    
    $tpl->replaceSection("COMMENT",$_content);

    if($post['status'] == '4')
      $tpl->replaceSection("NEW_COMMENT"); // Archived stories can't be commented on
  }

  if($Blog->settings['allow_pings'] != '1' || $post['allow_pings'] != '1')
    $tpl->replaceSection("TRACKBACKS");
  else
  {
    $comment_arr = $Blog->listTBacksForPost($post_id);
    $cmmt_section = $tpl->cutSection('TRACKBACK');
    $_content='';
    $_temp = new Wtemplate;

    for($i=0;$i<count($comment_arr);$i++)
    {
      $comment_arr[$i]['created_on'] = adodb_date2($Blog->settings['date_format'].', G:i',$comment_arr[$i]['created_on']);
      $_temp->sTemplate = $cmmt_section;
      $_temp->replace(
        array(
          'COMMENTTITLE'=>$comment_arr[$i]['title'],
          'COMMENTCONTENT'=>$comment_arr[$i]['comment'],
          'REMOTE_BLOG'=>$comment_arr[$i]['remote_blog'],
          'URL'=>$comment_arr[$i]['url'],
          'COMMENTDATE'=>$comment_arr[$i]['created_on']
        )
      );
      $_content .= $_temp->out();
    }
    if(!empty($_content))
      $tpl->replaceSection("NO_TRACKBACK");
    
    $tpl->replaceSection("TRACKBACK",$_content);    
  }


  $tpl->replace(
    array(
      'PATH'=>'../',
      'FILE_EXT'=>$Blog->settings['archive_post_ext'],
      'SITE_URL'=>$Blog->settings['site_url'],
      'SITE_NAME'=>$Blog->settings['site_name'],
      'SITE_DESC'=>$Blog->settings['site_desc'],
      'SITE_KEYWORDS'=>$Blog->settings['site_keywords'],
      'ID'=>$post['id'],
      'POSTDATE'=>adodb_date2('l, F j',$post['created_on']),
      'UP_DATE'=>adodb_date2($Blog->settings['date_format'].', G:i',$post['updated_on']),
	    'POSTTITLE'=>$post['title'],
      'POSTCONTENT'=>($post['story'] . $post['extended_story']),
      'AUTHORNAME'=>($post['first_name'].' '.$post['last_name']),
      'PERMALINK'=>($Blog->settings['site_url'].'/archive/'.$post['id'].$Blog->settings['archive_post_ext']),
      'TRACKBACK_URL'=>($Blog->settings['site_url'].'/trackback.php?story_id='.$post['id']),
      'ABSTRACT'=>$post['abstract'],
      'CREATED_ON'=>$post['created_on']
    )  
  );
  $file = $current_path.'archive/'.$post_id.$Blog->settings['archive_post_ext'];
  $fp = fopen($file,'w');
  fwrite($fp,$tpl->out());
  fclose($fp);
  // and now, cache the appropriate monthly archive
  $datearr = explode(" ",adodb_date2('m Y',$post['created_on']));
  if($archive_monthly_too === true)
    cache_monthly($Blog,$datearr[0],$datearr[1],$current_path);
}

function cache_monthly($Blog, $month, $year,$path='./')
{
  if(strlen($month)==1)
    $month = '0'.$month;
  $post_arr = $Blog->getPostsForMonth($month,$year);
  $file = $path.'archive/'.$year.'_'.$month.$Blog->settings['archive_post_ext'];
  return cache_generic($post_arr, $file, $Blog, $path, 'monthly');
}

function cache_monthly_all($Blog,$path='./')
{
  $arr = $Blog->monthly_archives();
  for($i=0;$i<count($arr);$i++)
  {
    cache_monthly($Blog,$arr[$i]['archive_month'],$arr[$i]['archive_year'],$path);
  }
}

function cache_main($Blog,$id=false,$path='./')
{
  if($Blog->is_current($id) || empty($id))
    @unlink($path.'archive/index.html');
}

function cacheByTopic($Blog, $topicID=false, $path='./')
{
  $t = $Blog->listTopics();
  $list = $Blog->getPostsForTopic($topicID);
  while(list($tID, $posts)=each($list))
  {
    if(empty($posts)) continue;
    $filename = $path.'archive/'.tweakFilename($t[$tID]).$Blog->settings['archive_post_ext'];
    cache_generic($posts, $filename, $Blog, $path, 'byTopic');
  }
}

function cache_generic($post_arr, $filename, $Blog, $path, $cacheType)
{
  $tpl = new WTemplate;
  $tpl->debug=false;
  $tpl->setPath($path.'template');
  $tpl->setExtension('html');
  $tpl->init('archive');

  $_temp = new WTemplate;
  $post_section = $tpl->cutSection("POST");


  for($i=0;$i<count($post_arr);$i++)
  {
    if($i<$Blog->settings['headlines_no']) 
      $headlines[] = '<li><a href="#'.$post_arr[$i]['id'].'">'.($post_arr[$i]['title']).'</a></li>'."\n";
    $_temp->sTemplate = $post_section;

    if($Blog->settings['allow_comments'] != '1' || $post_arr[$i]['allow_comments'] != '1')
      $_temp->replaceSection("COMMENTS");

    if($Blog->settings['allow_pings'] != '1' || $post_arr[$i]['allow_pings'] != '1')
      $_temp->replaceSection("TRACKBACKS");

    $created_on = $post_arr[$i]['created_on'];
    $post_arr[$i]['created_on'] = adodb_date2('l, F j',$post_arr[$i]['created_on']);
    if($post_arr[$i]['created_on'] == $post_arr[($i-1)]['created_on'])
      $_temp->replaceSection("POSTDATEH");

    $storyRefList = $Blog->listStoryReferences($post_arr[$i]['id']);
    if(!empty($storyRefList))
    {
      $_reflst = '';
      foreach($storyRefList AS $row)
        $_reflst .= '<a href="'.$row['reference_url'].'" target="_blank"/>'.$row['reference_title'].'</a><br/>';
      $_temp->replace("REF_LST",$_reflst);
    }
    else
      $_temp->replaceSection("STORY_REF_LST");

    $storyTopics = $Blog->listStoryTopics($post_arr[$i]['id']);
    if($Blog->use_topics == '1' && !empty($storyTopics))
    {
      $topix = array();
      while(list(, $topNAME)=each($storyTopics))
        $topix[] = '<a href="'.$Blog->settings['site_url'].'/archive/'.tweakFilename($topNAME).$Blog->settings['archive_post_ext'].'">'.$topNAME.'</a>';
      $_temp->replace("STORY_TOPICS",implode(", ", $topix));
    }
    else
    {
      $_temp->replaceSection("POSTCAT");
    }

    $date_created_formatted[$i] = adodb_date2('l, F j, Y', $post_arr[$i]['created_on']);
    $date_updated_formatted[$i] = adodb_date2($Blog->settings['date_format'].', G:i', $post_arr[$i]['updated_on']);

    $_temp->replace(
      array(
        'ID'=>$post_arr[$i]['id'],
        'POSTDATE'=>$post_arr[$i]['created_on'],
        'UP_DATE'=>$date_updated_formatted[$i],
        'POSTTITLE'=>$post_arr[$i]['title'],
        'POSTCONTENT'=>$post_arr[$i]['story'],
        'AUTHORNAME'=>($post_arr[$i]['first_name'].'&nbsp;'.$post_arr[$i]['last_name']),
        'COMMENTS_CNT'=>($Blog->settings['allow_comments']=='1' ? $Blog->getCommentCntForPost($post_arr[$i]['id']):''),
        'TBACK_CNT'=>($Blog->settings['allow_pings']=='1' ? $Blog->getTBackCntForPost($post_arr[$i]['id']):'')
      )  
    );
    $_content .= $_temp->out();
  }

  $tpl->replaceSection("POST",$_content);
  $tpl->replace(
    array(
      'PATH'=>'../',
      'SELF'=>$filename,
      'FILE_EXT'=>$Blog->settings['archive_post_ext'],
      'SITE_URL'=>$Blog->settings['site_url'],
      'SITE_NAME'=>$Blog->settings['site_name'],
      'SITE_DESC'=>$Blog->settings['site_desc'],
      'SITE_KEYWORDS'=>$Blog->settings['site_keywords'],
      'MONTHNAME'=>adodb_date2('F',$created_on), // hack ;)
      'YEAR'=>$year,
      'RECENT'=>(is_array($headlines)?implode('',$headlines):''),
      'ARCHIVES'=>show_archives($Blog,$Blog->monthly_archives())
      )  
    );

    if($cacheType=='monthly') 
      $tpl->replace("ARCHIVE_TITLE",(adodb_date2('F',$created_on).' '.adodb_date2('Y',$created_on)));
    else if($cacheType=='byTopic')
      $tpl->replace("ARCHIVE_TITLE",array_shift($storyTopics));
    else
      $tpl->replace("ARCHIVE_TITLE","Archive");
  //echo 'Processing file '.$filename.'<br/>';
  $fp = fopen($filename,'w');
  if(is_resource($fp))
  {
    fwrite($fp,$tpl->out());
    fclose($fp);
    return true;
  }
  else
  {
    return false;
  }
}


function tweakFilename($f)
{
  return str_replace(" ","-",$f);
}

function publish_scheduled($Blog)
{
  $sScheduled = 3; // ID from cs_story_status
  $crit = array('status'=>$sScheduled,'scheduled_for_date'=>"<=".date("Y-m-d"));
  $res = $Blog->search($crit);
  if($res->fields['id'] != '')
  {
    // there are unpublished, scheduled stories
    while(!$res->EOF)
    {
      $Blog->publish($res->fields['id']);
      $Blog->post(array('id'=>$res->fields['id'],'created_on'=>$res->fields['scheduled_for_date'])); // FIXME
      cache_single($Blog,$res->fields['id']);
      $res->MoveNext();
    }
    cache_main($Blog,$newid);
    return true;
  }
  else
    return false;
}

function autoArchive($Blog)
{
  if($Blog->settings['auto_archive_after'] == 0 || !isset($Blog->settings['auto_archive_after']) || !in_array($Blog->settings['auto_archive_unit'], array('HOUR','DAY','MONTH')))
    return false;
  if(strpos($Blog->db->databaseType, 'postgres') !== false)
  {
    $sql = "SELECT id FROM cs_story WHERE status=2 AND updated_on < (CURRENT_DATE - INTERVAL '".$Blog->settings['auto_archive_after']." ".$Blog->settings['auto_archive_unit']."') ORDER BY id DESC";
  }
  else
  { //mysql
    $sql = "SELECT id FROM cs_story WHERE status=2 AND updated_on < date_sub(CURDATE(), INTERVAL ".$Blog->settings['auto_archive_after']." ".$Blog->settings['auto_archive_unit'].") ORDER BY id DESC";
  }
  $res = $Blog->db->execute($sql);
  if(is_object($res) && $res->fields['id'] != '')
  {
    while(!$res->EOF)
    {
      $Blog->archiveStory($res->fields['id']);
      cache_single($Blog,$res->fields['id']);
      $res->MoveNext();
    }
    cache_main($Blog,$newid);
    return true;
  }
  else
    return false;
}
?>