<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             | 
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

// trackback a weblog
function trackback_others($Blog,$my_story_id,$post_data)
{
  $title = $post_data['title'];
  $excerpt = substr(strip_tags($post_data['story']),0,255) . ' ...';
  $urls = explode(";",$post_data['trackback_url']);
  $res = array();
  for($i=0;$i<count($urls);$i++)
  {
    if(!empty($urls[$i]))
      $res[$urls[$i]] = $Blog->trackback($urls[$i], $title, $excerpt, $my_story_id);
  }
  return $res;
}

function pingRemoteSites($Blog)
{
  if(!empty($Blog->settings['ping_sites']))
  {
    $sites = explode(";",$Blog->settings['ping_sites']);
    $result = array();
    foreach($sites AS $site)
    {
      $sql = "SELECT remote_server, remote_path, remote_method FROM cs_rpc_service WHERE service_name='".$site."'";
      $res = $Blog->db->Execute($sql);
      if(is_object($res) && !empty($res->fields))
      {
        $updatePing=new xmlrpcmsg($res->fields['remote_method'], array(new xmlrpcval($Blog->settings['site_name'], "string"), new xmlrpcval($Blog->settings['site_url'], "string")));
        $httpRequest=new xmlrpc_client($res->fields['remote_path'], $res->fields['remote_server'], 80);
        $xmlResponse=$httpRequest->send($updatePing);
        $methodValue=$xmlResponse->value();
        if(!$xmlResponse->faultCode())
        {
          $tmp = $methodValue->structmem('flerror');
          $success  = $tmp->scalarval();
          $tmp = $methodValue->structmem('message');
          $response = $tmp->scalarval();
        }
        else
        {
          $success = 0;
          $response = $xmlResponse->faultString();
        }
      }
      else
      {
        $success = 0;
        $response = $site.': no such service.';
      }
      $result[$site] = array($success, $response);
    }
  }
  return $result;
}

// reads reference URL and parses RDF information
function getReferenceStoryInfo($url)
{
  $fp = fopen($url,'r');
  if(is_resource($fp))
  {
    while(!feof($fp))
      $s .= fread($fp,4096);
    if(eregi("\<rdf\:rdf.*</rdf:rdf>",$s,$regs)) //\<\/rdf\:rdf\>
    {
      if(substr(phpversion(),0,1) == '4')
      {
        $xmldoc = domxml_open_mem($regs[0]);
        $root = $xmldoc->document_element(); 
        $nodes = $root->child_nodes();
        $attribList = array();
        for($i=0;$i<count($nodes);$i++)
        {
          if($nodes[$i]->tagname == 'Description')
          {
            $attrib = $nodes[$i]->attributes();
            if(is_array($attrib))
            {
              foreach($attrib AS $att)
              {
                $attribList[$att->name] = $att->value;
              }
            }
          }
        }
      }
      else if(substr(phpversion(),0,1) == '5')
      { // I can't get DOM to work in PHP5 yet, let's hack
        $pos1 = strpos($regs[0],"<rdf:Description")+strlen("<rdf:Description");
        $pos2 = strpos($regs[0],"/>",$pos1) - $pos1;
        $rdf = trim(substr($regs[0], $pos1, $pos2));
        $arr = explode("\n",$rdf);
        $attribList = array();
        for($i=0;$i<count($arr);$i++)
        {
          $arr[$i] = trim($arr[$i]);
          $tmp1 = explode("=",$arr[$i]);
          $tmp2 = array_shift($tmp1);
          $tmp3 = implode("=",$tmp1);
          $tmp4 = explode(":",$tmp2);
          $attribList[$tmp4[1]] = substr($tmp3, 1, strlen($tmp3)-2);
        }
      }
      return $attribList;
    }
  }
}

function httpSend($request,$rsf)
{ 
  // request = query string, array(target_url, target_method)
  $request = substr($request,0,strlen($request)-1); 
  $tgt = substr($rsf["target_url"],strpos($rsf["target_url"],"/" ,7)); 
  $result = '';
  $host = substr($rsf["target_url"],7,strpos($rsf["target_url"],"/" ,7) - 7); 
  if(empty($host))
    return false;
  if(strtoupper($rsf["target_method"])=="POST")
  { 
    $header  = "POST " . $tgt . " HTTP/1.0\n"; 
    $header .= "Host: ".$host."\n";
    $header .= "Content-type: application/x-www-form-urlencoded\n"; 
    $header .= "Content-length: " . strlen($request) . "\n"; 
    $header .= "Connection: close\n\n";
  }
  else
  { 
    $header = "GET " . $tgt . "?" . $request . " HTTP/1.0\r\n\r\n"; 
  }
  $fp = fsockopen($host, 80, $err_num, $err_msg, 30); 
  if($fp)
  { 
    if(strtoupper($rsf["target_method"])=="POST")
    { 
      fputs($fp, $header . $request); 
    }
    else
    { 
      fputs($fp, $header); 
    } 
    while(!feof($fp))
      $result .= fgets($fp, 4096);
    fclose($fp);
  } 
  return $result;
}
?>