<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             | 
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

function print_pre($arr)
{
  echo "<pre>\n";
  print_r($arr);
  echo "</pre>\n";
}

function trimall($obj)
{
  if(is_string($obj))
    return trim($obj);
  else if(is_array($obj))
  {
    reset($obj);
    while(list($k,$v)=each($obj))
    {
      $obj[$k] = trimall($v);
    }
  }
  return $obj;
}

function unhtmlall($obj)
{
  if(is_string($obj))
    return htmlentities($obj, ENT_NOQUOTES, 'UTF-8');
  else if(is_array($obj))
  {
    reset($obj);
    while(list($k,$v)=each($obj))
    {
      $obj[$k] = htmlentities($v, ENT_NOQUOTES, 'UTF-8');
    }
  }
  return $obj;
}

function filter_for_search($s)
{
  if(!isset($s)) return false;
  $common_words = array(
    'and',
    'or',
    'a',
    'an',
    'the',
    'is',
    'are',
    'this',
    'that',
    "it's",
  ); // add others at will
  $s = trimall($s);
  $s = strip_tags($s);
  for($i=0;$i<count($common_words);$i++)
    $s = str_replace(' '.$common_words[$i].' ',"",$s);
  return $s;
}

function makelinks($str)
{
  return eregi_replace("(http://[^([:space:]\(\)<>#%:\{\}\|\\\^)]+[^([:space:]\(\)<>#%:\{\}\|\\\^\.)])","<a href=\"\\1\">\\1</a>",$str); 
}

function show_archives(&$Blog,$arr)
{
  $out = '';
  for($i=0;$i<count($arr);$i++)
  {
    if(strlen($arr[$i]['archive_month'])==1)
      $arr[$i]['archive_month'] = '0'.$arr[$i]['archive_month'];
    $out .= '<a href="'.$Blog->settings['site_url'].'/archive/'.$arr[$i]['archive_year'].'_'.$arr[$i]['archive_month'].'.html">';
    $out .=$arr[$i]['month_name'].'&nbsp;'.$arr[$i]['archive_year'];
    $out .= '</a><br/>'."\n";
  }
  return $out;
}

function show_blogroll(&$Blog)
{
  $out='';
  $cats = $Blog->listBookmarkCats();
  for($i=0;$i<count($cats);$i++)
  {
    $list = $Blog->list_bookmarks(1,$cats[$i]['id'],false);
    if(!empty($list))
    {
      $out .= '<h4>'.$cats[$i]['category'].'</h4>'."\n";
      foreach($list as $row)
        $out .= '<li><a href="'.$row['uri'].'" title="'.$row['long_name'].'">'.$row['short_name']."</a></li>\n";
    }
  }
  return $out;
}

function save_comment(&$Blog,$story_id,$c_arr)
{
  $c_arr = trimall($c_arr);
  //$newc = unhtmlall($newc);
  //$newc['comment'] = makelinks($newc['comment']);
  //$newc['comment'] = str_replace("\n","<br/>",$newc['comment']);
  if(!empty($c_arr['url']) && !ereg("^http:\/\/",$c_arr['url']))
    $c_arr['url'] = "http://".$c_arr['url'];
  if(is_array($c_arr) && !empty($c_arr['guest']) && !empty($c_arr['comment']))
  {
    if($Blog->addCommentToPost($story_id,$c_arr))
      return true;
  }
  return false;
}

function list_dir($dirname) 
{ 
  if($dirname[strlen($dirname)-1]!='/') 
  $dirname.='/'; 
  $result_array=array();   
  $handle=opendir($dirname); 
  while ($file = readdir($handle)) 
  { 
    if($file=='.'||$file=='..') 
    continue; 
    if(!is_dir($dirname.$file)) 
      $result_array[]=$dirname.$file; 
  } 
  closedir($handle); 
  return $result_array; 
}

function writeLog($db, $action)
{
  $sql = "INSERT INTO cs_logbook(action, created_on) VALUES('".addslashes(stripslashes($action))."',now())";
  return $db->execute($sql);
}

function firstwords($str,$wordcount)
{
  # Gareth (omnipotent.net) 0wnz m3.
  # Someday, I will be able to do this sort of thing when I grow up.
  $words=preg_split('/([\s.,;]+)/',$str,$wordcount+1,PREG_SPLIT_DELIM_CAPTURE);
  array_pop($words);
  return(implode('',$words));
} 

?>