<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             | 
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

class Select {

var $type;
var $size=1;
var $tabindex;
var $multiple;
var $name;
var $options;
var $event;
var $selected;

function Select($name=false,$options=false,$selected=array(),$event=array()) 
{
  if(!empty($name))
    return $this->load($name,$options,$selected,$event);
}

function load($name,$options=array(),$selected=array(),$event=array()) 
{
  $this->name=$name;
  $this->options=$options;
  $this->event=$event;
  $this->selected=$selected;
}

function show() 
{
  if(is_array($this->options))
  {
    reset($this->options);
  }
  $strbuf='<select name="' . $this->name . '"';
  if(!empty($this->event)) 
  {
    for ($i=0;$i<count($this->event);$i++)
    {
      $strbuf.=' ' . $this->event[$i]['name'] . '="' . $this->event[$i]['jsfunction'] . '"';
    } 
  }
  $strbuf.=' size="'.$this->size.'"';
  if($this->multiple===true)
  {
    $strbuf.=' MULTIPLE';
  }
  if(is_numeric($this->tabindex))
    $strbuf .= ' tabindex="'.$this->tabindex.'"';
  $strbuf.='>';
  if(is_array($this->options))
  {
    while (list($key,$val)=each($this->options)) 
    {
      $strbuf.='<option value="' . $key . '"';
      if((!is_array($this->selected) && $this->selected==$key) || (is_array($this->selected) && in_array($key,$this->selected)))
      {
        $strbuf.=' SELECTED';
      }
      $strbuf.='>' . $val . '</option>'; 
    }
  }
  $strbuf.="</select>\n";
  return $strbuf;
}


function addOption($id,$name)
{
  $this->options[$id] = $name;
}

function addOptions($arr)
{
  if(!is_array($arr)) return false;
  if(!is_array($this->options)) $this->options = array();
  while(list($k,$v)=each($arr))
  {
    $this->options[$k] = $v;
  } 
  return true;
}

function purgeOption($key)
{
  // removes a pair from SELECT options. The parameter can be either String or String Array
  if(empty($key))
    return false;
  $tmp = array();
  reset($this->options);
  while(list($k,$v)=each($this->options))
  {
    if(is_array($key))
    {
      if(!in_array($k,$key))
        $tmp[$k] = $v;
    }
    else
    {
      if($k != $key)
        $tmp[$k] = $v;
    }
  }
  $this->options = $tmp;
  return true;
}

}
?>