<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             | 
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

class WTemplate {

var $path;
var $extension;
var $sFile;
var $rFile;
var $sTemplate;
var $delim = array();
var $debug = false;

function WTemplate()
{
  $this->path = $GLOBALS['template_dir'];
  if(!eregi("\/$",$this->path))
    $this->path.="/";
  $this->extension = $GLOBALS['template_ext'];
  $this->delim = array("{","}");
  $this->debug = $GLOBALS['debug_mode'];
}

function init($_file,$openNow=true)
  {
    $file = $this->path . $_file . "." . $this->extension;
    if(is_file($file)) // is_file hazi error i kdyz je vsechno OK ;-)
    {
      $this->sFile = $file;
      if($openNow===true)
      {
        return $this->open();
      }
      return true;
    }
    else 
    {
      if($this->debug === true) $this->raiseError("Template file could not be found.");
      return false;
    }
  }


function setPath($path)
  {
  if($path[strlen($path)-1]!="/")
  $path.="/";
  $this->path=$path;
  return true;
  }

function setExtension($ext='tpl')
  {
  $this->extension=$ext;
  }

function open()
  {
  if(!empty($this->sFile))
    {
    $this->rFile=fopen($this->sFile,"r",0);
    if(is_resource($this->rFile))
      {
      $s='';
      while(!feof($this->rFile))
        {
        $s.=fgets($this->rFile,4096);
        }
      $this->sTemplate=$s;
      unset($s);
      @fclose($this->sFile);
      if(!empty($this->sTemplate))
        {
        return true;
        }
      else return false;
      }
    else return false;
    }
  else return false;
  }

function replace($aReplace,$sReplace=false) // simple replace
  {
  
  if(is_array($aReplace))
    {
    reset($aReplace);
    while(list($variable,$replacement)=each($aReplace))
      {
      $variable = $this->delim[0] . $variable . $this->delim[1];
      $this->sTemplate=str_replace($variable,$replacement,$this->sTemplate);
      }
    return true;
    }
  else if(is_string($aReplace)) // we can tolerate single-value params too, we will automatically replace the param with empty string 
    {
    $variable = $this->delim[0] . $aReplace . $this->delim[1];
    $this->sTemplate=str_replace($variable,$sReplace,$this->sTemplate);
    return true;
    }
  else return false;
  }


function cutSection($sSectionName)
  {
  $pos1=strpos($this->sTemplate,'<!SECTION NAME="'.$sSectionName.'"!>',0);
  $pos2=strpos($this->sTemplate,'<!END SECTION "'.$sSectionName.'"!>',$pos1)+strlen('<!END SECTION 
  "'.$sSectionName.'"!>');
  if($pos1!=false && $pos2!=false)
    return substr($this->sTemplate,$pos1,$pos2-$pos1);
  }

function getSection($sSectionName)
  {
  return $this->currentSection[$sSectionName];
  }

function replaceSection($sSectionName,$sBigString='')
{
  do
  {
    $pos1=strpos($this->sTemplate,'<!SECTION NAME="'.$sSectionName.'"!>',0);
    $pos2=strpos($this->sTemplate,'<!END SECTION "'.$sSectionName.'"!>',$pos1)+strlen('<!END SECTION "'.$sSectionName.'"!>');
    if($pos1!=false && $pos2!=false)
    {
      $this->sTemplate=substr_replace($this->sTemplate,$sBigString,$pos1,$pos2-$pos1);
    }
  }
  while($pos1 != false && $pos2 != false);
  return true;
}

function fillFormValues($input,$entity)
{
  if(!is_array($entity)) return $entity;
  reset($entity);
  while(list($k,$v)=each($entity))
  {
    if(is_string($v))
      $this->setFormVal($input."[$k]",$v);
    else if(is_array($v))
      $entity[$k] = $this->fillFormValues($input."[$k]",$v);
  }
}

function setFormVal($inputName,$inputValue)
  {
    $find = 'name="'.$inputName.'"';
    $replace = 'name="'.$inputName.'" value="'.$inputValue.'"';
    //echo "looking for $find, replacing with $replace, found at position #".strpos($this->sTemplate,$find)."<BR>";
    $this->sTemplate = str_replace($find,$replace,$this->sTemplate);
  }

function prepend($string)
  {
  $this->sTemplate=$string . $this->sTemplate;
  }

function append($string)
  {
  $this->sTemplate.=$string;
  }

function out()
  {
  $this->cleanup();
  return $this->sTemplate;
  }

function cleanup()
  {
  $str=array(
  '<!SECTION NAME="[az0-9\.-_]*"!>',
  '<!END SECTION "[az0-9\.-_]*"!>'
    );
  
  foreach($str AS $replace)
    {
    $this->sTemplate=eregi_replace($replace,"",$this->sTemplate);
    }
  }

function raiseError($errmsg)
  {
    echo  '<div id="wtemplate_error" style="border:1px solid black;background-color:#E4E4E4;padding:5 5  5 5;color:black;font-weight:bold;">WTemplate Exception encountered: '.$errmsg."</div>";
  }
}
?>
