<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/
include("lib/auth.lib");
// authenticate
$cookieName = 'wordsmith_sess_id';
$loggedUserData = array(); // this replaces $_SESSION['author_data']

if(!empty($_COOKIE[$cookieName]))
{
  // read user data
  $loggedUserData = wsGetUserData($db, $_COOKIE[$cookieName]);
  if(!empty($loggedUserData))
  {
    wsSetCookie($cookieName, $_COOKIE[$cookieName]);
    wsUpdateSession($db, $_COOKIE[$cookieName]);
    wsCleanseSessions($db);
  }
}

if(empty($_COOKIE[$cookieName]) || empty($loggedUserData))
{
  // we have to authenticate
  if(!empty($_REQUEST['login']) && !empty($_REQUEST['passwd']))
  {
    $loggedUserData = $Blog->login($_REQUEST['login'],$_REQUEST['passwd']);
    if(empty($loggedUserData))
    {
      // bad login
      writeLog($db, "Bad login with username '".$_REQUEST['login']."', password '".$_REQUEST['passwd']."'");
      $template->init('signin_error');
      echo $template->out();
      exit;
    }
    else
    {
      // authenticated
      $sessId = wsNewSessId();
      if(wsSetCookie($cookieName, $sessId) && wsNewSession($db, $loggedUserData['id'], $sessId))
      {
        // cleanse expired sessions
        wsCleanseSessions($db);
        // reload to prevent re-submit
        writeLog($db, "User '".$_REQUEST['login']."' logged in");
        $location = 'index.php';
        if(!empty($_REQUEST['q']))
          $location .= '?'.$_REQUEST['q'];
        header("Location: ".$location);
        exit;
      }
      else
      {
        // cookie set failed or could not create session
        // FIXME
      }
    }
  }
  else
  {
    $template->init('signin');
    $template->replace("QRY",$_SERVER['QUERY_STRING']);
    echo $template->out();
    exit;
  }
}
?>