<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/
if(!is_object($Blog)) exit;
$sectionName = 'Manage settings';
if($loggedUserData['is_admin'] != '1')
{
  include("template/unauthorized.html");
  exit;
}
if(!empty($_REQUEST['new_rpc_service']))
{
  foreach($_REQUEST['new_rpc_service'] AS $newRPC)
  {
    $tmp = explode("$", $newRPC);
    $rpcName = $tmp[0];
    $tmp = str_replace("http://","",$tmp[1]);
    $tmp = explode("/",$tmp);
    $rpcServer = $tmp[0]; array_shift($tmp);
    $rpcPath = implode("/",$tmp);
    $sql = "INSERT INTO cs_rpc_service(service_name, remote_server, remote_path, remote_method) VALUES('".$rpcName."','".$rpcServer."','/".$rpcPath."','weblogUpdates.ping')";
    $db->execute($sql);
  }
}
if(!empty($_REQUEST['set']) && is_array($_REQUEST['set']))
{
  $set = $_REQUEST['set'];
  // added new RPC service?
  $set['site_url'] = ereg_replace("\/$","",$set['site_url']); // no trailing slash
  if(is_array($set['ping_sites']))
    $set['ping_sites'] = implode(";",$set['ping_sites']);
  $params = array_keys($set);
  reset($Blog->settings);
  foreach($Blog->settings AS $key=>$val)
  {
    if(!in_array($key, $params))
      $set[$key]=0;
  }
  $Blog->saveSettings($set);
  header("Location: index.php?x=config");
  exit;
}

// default values
if(empty($Blog->settings['site_url']))
{
  $Blog->settings['site_url'] = 'http://'.$_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"];
  $_tmp = explode('/',$Blog->settings['site_url']);
  array_pop($_tmp);array_pop($_tmp);
  $Blog->settings['site_url'] = implode('/',$_tmp);
}
if(empty($Blog->settings['recordset_length']))
{
  $Blog->settings['recordset_length'] = 10;
}

$dateFormatPicklist = new Select;
$dateFormatPicklist->load('set[date_format]',array(''=>'Select:','m/d/Y'=>'Month/Day/Year','d.m.Y'=>'Day.Month.Year','Y-m-d'=>'Year-Month-Day'),$Blog->settings['date_format']);

$postExtPL = new Select;
$postExtPL->load('set[archive_post_ext]',array('.html'=>'.html','.php'=>'.php'),$Blog->settings['archive_post_ext']);


$tmzPL = new Select;
$tmzPL->load('set[timezone_difference]', array(''=>'Choose:'));
$tmzPL->addOptions($timezones);
$tmzPL->selected = $Blog->settings['timezone_difference'];

$rpcPL = new Select;
$rpcPL->load('set[ping_sites][]');
$rpcPL->multiple = true;
$resultSet = $Blog->getTabularDataSimple("cs_rpc_service");
$rpcServices = is_object($resultSet) ? $resultSet->getArray():array();
if(!empty($rpcServices) && is_array($rpcServices))
{
  foreach($rpcServices as $row)
    $rpcPL->addOption($row['service_name'],$row['service_name']);
}
if(!empty($Blog->settings['ping_sites']))
  $rpcPL->selected = explode(";",$Blog->settings['ping_sites']);
$rpcPL->size = count($rpcServices);

$autoArPL = new Select;
$autoArPL->load('set[auto_archive_unit]',array('HOUR'=>'hours','DAY'=>'days','MONTH'=>'months'), $Blog->settings['auto_archive_unit']);

if(empty($loggedUserData['email']))
  $tpl->replace("NOTIFY_COMMENTS_DISABLED"," DISABLED");
else
  $tpl->replace("NOTIFY_COMMENTS_DISABLED","");

$tpl->replace(
array(
  'SITE_NAME'=>$Blog->settings['site_name'],
  'SITE_URL'=>$Blog->settings['site_url'],
  'SITE_DESC'=>$Blog->settings['site_desc'],
  'SITE_KEYWORDS'=>$Blog->settings['site_keywords'],
  'AUTO_ARCHIVE_AFTER'=>$Blog->settings['auto_archive_after'],
  'AUTO_ARCHIVE_PL'=>$autoArPL->show(),
  'POST_EXT_PICKLIST'=>$postExtPL->show(),
  'TIMEZONE'=>$tmzPL->show(),
  'DATE_FORMAT_PICKLIST'=>$dateFormatPicklist->show(),
  'RPC_SERVICE_LIST'=>$rpcPL->show(),
  'RECORDSET_LENGTH'=>$Blog->settings['recordset_length'],
  'DAYS_PER_PAGE'=>$Blog->settings['days_per_page'],
  'HEADLINES_NO'=>$Blog->settings['headlines_no'],
  'DAYS_PER_XML'=>$Blog->settings['days_per_syndication'],
  'USE_TOPICS_CHECKED'=>($Blog->settings['use_topics'] == '1' ? ' CHECKED':''),
  'USE_SYND_CHECKED'=>($Blog->settings['use_syndication'] == '1' ? ' CHECKED':''),
  'SHOW_TIPS_CHECKED'=>($Blog->settings['show_tips'] == '1' ? ' CHECKED':''),
  'ALLOW_COMMENTS_CHECKED'=>($Blog->settings['allow_comments'] == '1' ? ' CHECKED':''),
  'ALLOW_PINGS_CHECKED'=>($Blog->settings['allow_pings'] == '1' ? ' CHECKED':''),
  'NOTIFY_COMMENTS_CHECKED'=>($Blog->settings['notify_comments'] == '1' ? ' CHECKED':''),
  'HANDLE_BANNED'=>$Blog->settings['handle_banned']
  )
);
?>