<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/
if(!is_object($Blog) || !$Blog->isLive()) exit;

$statArr = $Blog->listStoryStatus();

/* BEGIN Scrapbook */
if(!empty($_REQUEST['note']) && is_array($_REQUEST['note']))
{
  if($_REQUEST['del'] == '1')
  {
    $Blog->noteDelete($_REQUEST['note']['id'], $loggedUserData['id']);
  }
  else
  {
    $n = $_REQUEST['note'];
    $n['author_id'] = $loggedUserData['id'];
    $Blog->noteSave($n);
  }
  header("Location: index.php?x=diary");
  exit;
}

$topSelObj = new Select;
$topSelObj->load('note[topic_id]', array(''=>'Choose:'));
$topSelObj->addOptions($Blog->listTopics());
if($loggedUserData['is_admin'] == '1')
  $topSelObj->addOption('new','Add new:');
$topSelObj->event[] = array(
  'name'=>'onchange',
  'jsfunction'=>'addNewTopic(); return false;'
);

// paging
$page = (int) ((empty($_REQUEST['p'])) ? 1:$_REQUEST['p']);
$limit = (int) ((empty($_REQUEST['l'])) ? $Blog->settings['recordset_length']:$_REQUEST['l']);
if(empty($limit)) $limit=10;
// get the list
$nSec = $tpl->cutSection("NOTE_LIST");
$nSecTpl = new WTemplate;
$nTable = '';
$Note=array();
$ResultSet = $Blog->noteList($loggedUserData['id'], $page, $limit, $_REQUEST['filter']);// + page & nrows
if(is_object($ResultSet))
{
  $noteList = $ResultSet->getArray();
  $recTotal = $ResultSet->MaxRecordCount();
}
$recCount = -1;
if(is_array($noteList))
{
  foreach($noteList AS $row)
  {
    $recCount++;
    if(!empty($_REQUEST['note_id']) && $_REQUEST['note_id'] == $row['id'])
    {
      $Note = $row;
      $topSelObj->selected = $Note['topic_id'];
    }
    $_ = explode(" ", $row['created_on']);
    $created_on = '<div style="white-space: nowrap">'.$_[0].'</div><div style="white-space: nowrap">'.$_[1].'</div>';
    $nSecTpl->sTemplate = $nSec;
    $nSecTpl->replace(
      array(
        "SELF"=>$PHP_SELF,
        "ID"=>$row['id'],
        "DATE"=>$created_on,
        "AUTHOR"=>($row['last_name'].', '.$row['first_name']),
        "TOPIC"=>$row['topic'],
        "NOTE"=>$row['note'], //(strlen($noteTxt)<$noteLimit ? $noteTxt:substr($noteTxt,0,128).' [...]'),
        "PUBLISHED"=>(empty($row['published_on'])?"No":adodb_date2($Blog->settings['date_format'], $row['published_on']))
      )  
    );
    $nTable .= $nSecTpl->out();
  }

  $recFrom = ($page * $limit - $limit + 1);
  $recTo = $recFrom + $recCount;

  if($ResultSet->atFirstPage())
    $tpl->replaceSection("PREV_ICON");
  if($ResultSet->atLastPage())
    $tpl->replaceSection("NEXT_ICON");

}

$tpl->replaceSection("NOTE_LIST",$nTable);

$tpl->replace(
  array(
  'ID'=>$Note['id'],
  'NOTE'=>$Note['note'],
  'TOPIC_PL'=>$topSelObj->show(),
  "KW"=>stripslashes($_REQUEST['filter']['kw']),
  "REC_TOTAL"=>$recTotal,
  "REC_FROM"=>$recFrom,
  "REC_TO"=>$recTo,
  "CURPAGE"=>$page,
  "PREV_PAGE"=>$page-1,
  "NEXT_PAGE"=>$page+1,
  "LASTPAGE"=>ceil($recTotal/$limit),
  "CURLIMIT"=>$limit
  )
);
/* END Scrapbook  */

// statistics
$todayStats=array();
if($dbtype=='postgres')
{
  $sql='SELECT COUNT(DISTINCT created_on) AS hits, COUNT(DISTINCT ip) AS visits FROM cs_tracker GROUP BY created_on HAVING created_on=CURRENT_DATE';
}
else
{
  $sql='SELECT COUNT(DISTINCT created_on) AS hits, COUNT(DISTINCT ip) AS visits, DATE_FORMAT(created_on, "%Y-%m-%d") AS today FROM cs_tracker GROUP BY today HAVING today=CURDATE()';
}
$res=$db->execute($sql);
$todayStats['hits']=empty($res->fields['hits'])?0:$res->fields['hits'];
$todayStats['visits']=empty($res->fields['visits'])?0:$res->fields['visits'];
if($dbtype=='postgres')
{
  $sql='SELECT COUNT(id) AS stories_new FROM cs_story WHERE created_on=CURRENT_DATE';
}
else
{
  $sql='SELECT COUNT(id) AS stories_new FROM cs_story WHERE DATE_FORMAT(created_on, "%Y-%m-%d")=CURDATE()';
}
$res=$db->execute($sql);
$todayStats['stories_new']=$res->fields['stories_new'];
if($dbtype=='postgres')
{
  $sql='SELECT COUNT(id) AS stories_touched FROM cs_story WHERE updated_on=CURRENT_DATE';
}
else
{
  $sql='SELECT COUNT(id) AS stories_touched FROM cs_story WHERE DATE_FORMAT(updated_on, "%Y-%m-%d")=CURDATE()';
}
$res=$db->execute($sql);
$todayStats['stories_touched']=$res->fields['stories_touched'];
if($dbtype=='postgres')
{
  $sql='SELECT COUNT(id) AS comments FROM cs_comment WHERE created_on=CURRENT_DATE';
}
else
{
  $sql='SELECT COUNT(id) AS comments FROM cs_comment WHERE DATE_FORMAT(created_on, "%Y-%m-%d")=CURDATE()';
}
$res=$db->execute($sql);
$todayStats['comments']=$res->fields['comments'];
if($dbtype=='postgres')
{
  $sql='SELECT COUNT(id) AS trackbacks FROM cs_trackback WHERE created_on=CURRENT_DATE';
}
else
{
  $sql='SELECT COUNT(id) AS trackbacks FROM cs_trackback WHERE DATE_FORMAT(created_on, "%Y-%m-%d")=CURDATE()';
}
$res=$db->execute($sql);
$todayStats['trackbacks']=$res->fields['trackbacks'];
reset($todayStats);
foreach($todayStats AS $key=>$val)
  $tpl->replace($key, $val);

// recent stories
$res = $Blog->search(array(), $pg=1, $rc=5);
$arr = is_object($res)?$res->getAll():array();
$stTbl = '';
foreach($arr AS $row)
{
  $stTbl .= '<tr><td>'.$db->UserDate($row['created_on'],$Blog->settings['date_format']). '</td><td>'.$row['last_name'].', '.$row['first_name'].'</td><td>';
  if($loggedUserData['is_admin'] == '1' || $loggedUserData['id'] == $row['author_id'])
    $stTbl .= '<a href="?x=post&id='.$row['id'].'">'.$row['title'].'</a>';
  else
    $stTbl .= $row['title'];
  $stTbl .= '</td><td>'.$statArr[$row['status']].'</td></tr>'."\n";
}

// recent comments
$sql = "SELECT a.story_id, a.created_on, a.comment, b.title, b.author_id FROM cs_comment AS a JOIN cs_story AS b ON(b.id=a.story_id) ORDER BY a.created_on DESC";
$res = $db->PageExecute($sql, $nrows=5, $pg=1);
$arr = is_object($res)?$res->getAll():array();
$cmtTbl = '';
foreach($arr AS $row)
{
  $cmtTbl .= '<tr><td>'.adodb_date2($row['created_on'],$Blog->settings['date_format'] .' G:i'). '</td><td>';
  if($loggedUserData['is_admin'] == '1' || $loggedUserData['id'] == $row['author_id'])
    $cmtTbl .= '<a href="?x=feedback&id='.$row['story_id'].'">'.$row['title'].'</a>';
  else
    $cmtTbl .= $row['title'];
  $cmtTbl .= '</td><td>'.substr(strip_tags($row['comment']),0,125).'...</td></tr>'."\n";
}

// recent trackbacks
$sql = "SELECT a.story_id, a.created_on, a.comment, a.url, b.title, b.author_id FROM cs_trackback AS a JOIN cs_story AS b ON(b.id=a.story_id) ORDER BY a.created_on DESC";
$res = $db->PageExecute($sql, $nrows=5, $pg=1);
$arr = is_object($res)?$res->getAll():array();
$tbcTbl = '';
foreach($arr AS $row)
{
  $tbcTbl .= '<tr><td>'.adodb_date2($row['created_on'],$Blog->settings['date_format'] .' G:i'). '</td><td>';
  if($loggedUserData['is_admin'] == '1' || $loggedUserData['id'] == $row['author_id'])
    $tbcTbl .= '<a href="?x=feedback&id='.$row['story_id'].'">'.$row['title'].'</a>';
  else
    $tbcTbl .= $row['title'];
  $tbcTbl .= '</td><td>'.substr(strip_tags($row['comment']),0,125).'...<br/><b>Trackbacked at</b> <a href="'.$row['url'].'">'.$row['url'].'</a></td></tr>'."\n";
}

$tpl->replace(
  array(
    "BLOGNAME"=>$Blog->settings['site_name'],
    "USER"=>$loggedUserData['first_name'].' '.$loggedUserData['last_name'],
    "STORIES"=>$stTbl,
    "COMMENTS"=>$cmtTbl,
    "TBACKS"=>$tbcTbl
    )
  );
?>