<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

$_path = '../';
include_once($_path."config.inc.php");
include_once($_path."startup_db.inc.php");
include_once($_path."lib/xmlrpc-2.5.php");
include_once($_path."lib/select.class.php");
include_once("../lib/geoip.inc.php");

if($_db_unavailable==TRUE)
{
  include('template/db_error.html');
  exit;
}

if($Blog->golive($db) != TRUE)
{
  // something in the db isn't right - probably no tables present
  include('template/db_schema_error.html');
  exit;
}

$template = new WTemplate;
$template->debug=false;
$template->setPath('template');
$template->setExtension('html');

# some global variables
$timezones = array(
  13 =>'UTC+13 (New Zealand Daylight Savings Time)',
  12 =>'UTC+12 (International Date Line East)',
  11 =>'UTC+11',
  10 =>'UTC+10 (East Australian Time)',
  9.5=>'UTC+9.5 (Central Australian Time)',
  9  =>'UTC+9 (Japan Time)',
  8  =>'UTC+8 (China Coast Time)',
  7  =>'UTC+7 (West Australian Time)',
  6.5=>'UTC+6.5 (North Sumatra)',
  6  =>'UTC+6 (Russian Federation Zone 5)',
  5.5=>'UTC+5.5 (Indian)',
  5  =>'UTC+5 (Russian Federation Zone 4)',
  4  =>'UTC+4 (Russian Federation Zone 3)',
  3.5=>'UTC+3.5 (Iran)',
  3  =>'UTC+3 (Baghdad Time/Moscow Time)',
  2  =>'UTC+2 (Eastern Europe Time)',
  1  =>'UTC+1 (Central European Time)',
  0  =>'UTC+0 (Universal Time Coordinated)',
  -1 =>'UTC-1 (West Africa Time)',
  -2 =>'UTC-2 (Azores Time)',
  -3 =>'UTC-3 (Atlantic Time)',
  -3.5=>'UTC-3.5 (Newfoundland)',
  -4 =>'UTC-4 (Atlantic Time)',
  -5 =>'UTC-5 (Eastern Time)',
  -6 =>'UTC-6 (Central Time)',
  -7 =>'UTC-7 (Mountain Time)',
  -8 =>'UTC-8 (Pacific Time)',
  -9 =>'UTC-9 (Alaskan Time)',
  -10=>'UTC-10 (Aleutians-Hawaii Time)',
  -11=>'UTC-11 (Nome Time)'
  );
# now, authenticate or die()
include("auth.inc.php");

$template->init('index');
$tpl = new Wtemplate; 
$tpl->debug=false;
$tpl->setPath('./template');
$tpl->setExtension('html');

$section = $_REQUEST['x'];
/* Force user to save settings before he cau start using his blog */
if(empty($Blog->settings['site_url']))
  $section = 'config';

if(!is_file($section.'.php') || empty($section))
  $section = 'diary';
$tpl->init($section);

if(is_file($section.'.php'))
{
  include($section.'.php');
}

if($loggedUserData['is_admin'] != '1')
  $template->replaceSection("ADMIN_ONLY");

if($Blog->settings['show_tips'] != '1')
  $tpl->replaceSection("TIP");

$template->replace("SECTION",$tpl->out());

if(empty($sectionName))
  $sectionName = 'Administration';

$template->replace(
  array(
    'SELF'=>$PHP_SELF,
    'SITE_URL'=>$Blog->settings['site_url'],
    'USER'=>$loggedUserData['first_name'].' '.$loggedUserData['last_name'],
    'APPTITLE'=>($Blog->settings['site_name'].' :: '.$sectionName)
  )
);

header("Content-type: text/html; charset=UTF-8");
echo $template->out();
?>