<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

// Blogroll management
$sectionName = 'My neighborhood';
if(!is_object($Blog)) exit;
if($loggedUserData['is_admin'] != '1')
{
  include("template/unauthorized.html");
  exit;
}

if(!empty($_REQUEST['bg']))
{
  $link_cats = $Blog->listBookmarkCats();
  $edit_cats = $_REQUEST['bg'];
  $edit_IDs = array_keys($_REQUEST['bg']);
  for($i=0;$i<count($link_cats);$i++)
  {
    if(!in_array($link_cats[$i]['id'], $edit_IDs) && $link_cats[$i]['bookmarks']==0)
      $Blog->removeBookmarkCat($link_cats[$i]['id']);
  }
  reset($edit_cats);
  $index = 0;
  while(list($id, $data)=each($edit_cats))
  {
    $index++;
    if($id=='new')
    {
      foreach($data as $newCat)
      {
        $newCat = trim($newCat);
        if(!empty($newCat))
        {
          $Blog->addBookMarkCat($newCat, $index);
          $index++;
        }
      }
    }
    else
    {
      $Blog->modifyBookmarkCat($id, $data, $index);
    }
  }
  unset($_REQUEST['bg']);
}

$b_stats = array(0=>"Unlisted",1=>"Listed"); // two possible link statuses
// get links categories
$link_cats = $Blog->listBookmarkCats();
$catSel = new Select;
$catSel->load('b[cat_id]',array(),$_REQUEST['cat_id']);
if(!empty($link_cats))
{
  $b_cat_tbl = '';
  $b_cat_arr="cats = [\n";
  for($i=0;$i<count($link_cats);$i++)
  {
    $catSel->addOption($link_cats[$i]['id'],$link_cats[$i]['category']);
    $b_cat_arr .= "[".$link_cats[$i]['id'].",'".addslashes($link_cats[$i]['category'])."'],\n";
    $b_cat_tbl .= '<tr align="center"><td><input type="text" class="editField" name="bg['.$link_cats[$i]['id'].']" value="'.$link_cats[$i]['category'].'"/></td><td><a href="#" onclick="removeBG(this)"><img src="gfx/delete.jpg" width="11" height="12" border="0" alt="remove group"></a></td><td><a href="#" onclick="moveRowUp(this)"><img src="gfx/arrow_up.jpg" width="12" height="12" border="0" alt="move up"></a>&nbsp;<a href="#" onclick="moveRowDown(this);"><img src="gfx/arrow_down.jpg" width="12" height="12" border="0" alt="move down"></a></td></tr>'."\n";
  }
  $b_cat_arr = substr($b_cat_arr,0,(strlen($b_cat_arr)-2)); // remove \n, from the end
  $b_cat_arr .= '];';
}
if(empty($_REQUEST['cat_id'])) $catSel->selected =1;
// operations
if(!empty($_REQUEST['category_new']))
{
  $newid = $Blog->addBookmarkCat($_REQUEST['category_new'],1);
  if(!empty($newid))
    $link_cats[] = array($newid=>$_REQUEST['category_new']);
  $_REQUEST['b']['cat_id'] = $newid;
}
if(!empty($_REQUEST['b']) && is_array($_REQUEST['b']))
{
  $bdata = $_REQUEST['b'];
  if(!empty($bdata['uri']) && (empty($bdata['short_name']) || empty($bdata['rss_file'])))
  {
    // we'll try to query the server for information
    $fp = @fopen($bdata['uri'], 'r');
    if(is_resource($fp))
    {
      
      $s='';
      while( !eregi("\<\/head\>",$s) && !feof($fp) )
        $s .= fgets($fp, 4096);
      if(!empty($s))
      {
        if(eregi("\<title\>.*\<\/title\>",$s, $regs) && eregi("\>.*\<", $regs[0], $tmp) && empty($bdata['short_name']))
        {  
          $bdata['short_name'] = substr($tmp[0],1,strlen($tmp1)-1);
          $bdata['long_name'] = $bdata['short_name'];
        }
        if(eregi('http\:\/\/[a-z0-9\/\.]*rdf', $s, $regs))
          $bdata['rss_file'] = $regs[0];
        else if(eregi('http\:\/\/[a-z0-9\/\.]*xml', $s, $regs))
          $bdata['rss_file'] = $regs[0];
        else if(eregi('http\:\/\/[a-z0-9\/\.]*rss', $s, $regs))
          $bdata['rss_file'] = $regs[0];
      }
    }
  }

  $Blog->manage_bookmark($bdata);
  $cat_id = $catSel->selected = $bdata['cat_id'];
  //@unlink("../archive/index.html"); // so that the homepage is updated immediately
  //header("Location: ".$PHP_SELF."?x=neighborhood");
  //exit;
}
else
{
  if(strlen($_REQUEST['cat_id'])==0) $cat_id=false;
  else $cat_id = $_REQUEST['cat_id'];
  if(strlen($_REQUEST['stat_id'])==0) $stat_id=false;
  else $stat_id = $_REQUEST['stat_id'];
  if(strlen($_REQUEST['hasRss'])==0) $hasRss=false;
  else $hasRss = $_REQUEST['hasRss'];
}

if(!empty($_REQUEST['b_id']) && $_REQUEST['statchg']=='1')
{
  $Blog->toggleBookmarkStatus($_REQUEST['b_id']);
}
// display
$newsFeeds=array(''=>'Select a feed:');
$bookmark_list = $Blog->list_bookmarks($stat_id,$cat_id,$hasRss);
if(empty($bookmark_list)) $bookmark_list=array();
// process list of bookmarks
$_temp = new Wtemplate;
$_t = $tpl->cutSection("B_ROW");
$_s = '';
$b_js_arr='';
reset($bookmark_list);
$_odd=true;
foreach($bookmark_list as $b)
{
  $_temp->sTemplate = $_t;
  $_temp->replace(
    array(
    'B_ID'=>$b['id'],
    'B_SHORT_NAME'=>$b['short_name'],
    'B_HAS_RSS'=>(!empty($b['rss_file'])?'Yes':'No'),
    'B_CATNAME'=>$catSel->options[$b['cat_id']],
    'B_DATE_ADDED'=>$db->UserDate($b['created_on'], $Blog->settings['date_format']),
    "B_STATUS"=>$b_stats[$b['active']],
    "B_STAT_CHANGE_STR"=>(($b['active']=='1')?'unlist':'list'),
    "TR_CLASSNAME"=>($_odd?'odd':'even')
    )  
  );
  $_s .= $_temp->out();

  $b_js_arr .= 'bookmark_list['.$b['id'].'] = new BookMark('.$b['id'].",'".$b['cat_id']."','".$b['uri']."','".addslashes($b['short_name'])."','".addslashes($b['long_name'])."','".$b['rss_file']."');\n";

  $_odd = (!$_odd) ? true:false;
  if(!empty($b['rss_file']))
    $newsFeeds[$b['rss_file']] = $b['short_name'];
}
$tpl->replaceSection("B_ROW",$_s);

$newsPL = new Select;
$newsPL->load("news", $newsFeeds);
$newsPL->event[] = array(
  'name'=>'onchange',
  'jsfunction'=>'loadFeed(this)'
);
$filterSearchJS = '';
if(strlen($stat_id) != 0)
  $filterSearchJS .= 'filterSearch("status",'.$stat_id.');'."\n";
if($cat_id !== false)
  $filterSearchJS .= 'filterSearch("category",'.$cat_id.');'."\n";
if($hasRss !== false)
  $filterSearchJS .= 'filterSearch("syndicated",'.$hasRss.');'."\n";

$tpl->replace(
  array(
    'CAT_ID'=>$_REQUEST['cat_id'],
    'STAT_ID'=>$_REQUEST['stat_id'],
    'BOOKMARK_ARR'=>$b_js_arr,
    'CAT_ARR'=>$b_cat_arr,
    'CATEGORY_TABLE'=>$b_cat_tbl,
    'FILTER_COLS'=>$filterSearchJS,
    'FEEDS'=>$newsPL->show()
  )
);

$tpl->replace("CATEGORY_PULLDOWN",$catSel->show());
?>