<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

// must be included in index.php !
if(!is_object($Blog)) exit;
$sectionName = 'Post';

$statSelObj = new Select;
$statSelObj->load('p[status]',$Blog->listStoryStatus());
$statSelObj->event[] = array('name'=>'onchange','jsfunction'=>'toggleScheduledForDiv();');

// load last 10 post for quick edit
$sql = "SELECT id, title, created_on FROM cs_story ";
if($loggedUserData['is_admin'] != '1')
  $sql .= 'WHERE author_id='.$loggedUserData['id'];
$sql .= " ORDER BY created_on DESC";
$res = $db->PageExecute($sql,10,1);
$last10PL = new Select;
$last10PL->load('last10',array(''=>'Select a story for quick edit:'));
$last10PL->event[] = array(
  'name'=>'onchange',
  'jsfunction'=>'quickEdit(this)'
);
while(!$res->EOF)
{
  $opTitle = strip_tags($res->fields['title']) .' ['.$db->UserDate($res->fields['created_on'], $Blog->settings['date_format']).']';
  $last10PL->addOption($res->fields['id'], $opTitle);
  $res->MoveNext();
}

// read
if(!empty($_REQUEST['id']))
{
  $post = $Blog->getSinglePost($_REQUEST['id']);
  if($loggedUserData['is_admin'] != '1' && $loggedUserData['id'] != $post['author_id'])
  {//unauthorized
    include("template/unauthorized.html");
    exit;
  }
  if(!empty($post))
  {
    $_neworedit = 'Edit <span class="storyTitle">"'.$post['title'].'"</span>';
    $postRef = $Blog->listStoryReferences($post['id']);
    $statSelObj->selected = $post['status'];
    $storyTopics = $Blog->listStoryTopics($_REQUEST['id']);
    $allTopics   = $Blog->listTopics();
    $stTopLst='';
    while(list($k,$v)=each($allTopics))
    {
      $stTopLst .= '<input type="checkbox" name="p[topic][]" value="'.$k.'"';
      if($storyTopics[$k] != false)
        $stTopLst .= 'CHECKED';
      $stTopLst .= '/>'.$v.'<br/>';
    }
    if($loggedUserData['is_admin'] != '1')
      $tpl->replaceSection('ADDNEWCAT');
    if($post['allow_comments'] == '1')
      $tpl->replace("ALLOW_COMMENTS_CHECKED","CHECKED");
    if($post['allow_pings'] == '1')
      $tpl->replace("ALLOW_PINGS_CHECKED","CHECKED");
  }
  else
  {
    $_neworedit = 'Failed to load post. Create a new one instead.';
    $post=array();
    $com=array();
  }

}
else
{
  $_neworedit = 'New entry';
  $tpl->replaceSection('VIEW_COM');
}

// now check/not check boxes according to the global comment/ping rule - if we didn't do so above
if($Blog->settings['allow_comments'] == '1')
  $tpl->replace("ALLOW_COMMENTS_CHECKED",'CHECKED');
if($Blog->settings['allow_pings'] == '1')
  $tpl->replace("ALLOW_PINGS_CHECKED",'CHECKED'); 
/** 
  We have to filter the array of possible story statuses.
  The rules are:
    1. For a new post, only Draft, Published or Scheduled statuses are possible
    2. For an existing post in Draft status, only Draft, Published or Scheduled statuses are possible
    3. For an existing post in Published status, only Published, Archived or Deleted statuses are possible
    4. For a Scheduled post, only Scheduled or Published statuses are possible
    5. For an Archived post, only Archived or Deleted statuses are possible
    6. For a Deleted post, there should be an option for resurrection to Published status
**/

if(empty($post))
{
  $statSelObj->purgeOption(array(4,5));
}
else
{
  switch($post['status'])
  {
    case 1:
      $statSelObj->purgeOption(array(4,5));
    break;
    case 2:
      $statSelObj->purgeOption(array(1,3));
    break;
    case 3:
      $statSelObj->purgeOption(array(1,4,5));
    break;
    case 4:
      $statSelObj->purgeOption(array(1,2,3));
    break;
    case 5:
      $statSelObj->purgeOption(array(1,3,4));
      $tpl->replaceSection("COMMUNICATION");
    break;
  }
}

if(!empty($postRef))
{
  foreach($postRef as $ref)
  {
    $_refList .= '<tr><td><a href="'.$ref['reference_url'].'" target="_blank" title="Opens in a new window">'.$ref['reference_title'].'</a></td><td>'.$ref['reference_ping'].'</td><td align="center" colspan="2">'.(empty($ref['pinged_on'])?'-':$ref['pinged_on']).'</td></tr>';
  }
}

$_scheduled4date = explode('-',$post['scheduled_for_date']);

if(empty($Blog->settings['use_topics']))
  $tpl->replaceSection("TOPICS");


if(empty($_postSuccessMsg))
  $tpl->replaceSection("ERROR");

$tpl->replace(
  array(
  'ID'=>$post['id'],
  'NEW_EDIT_HEADING'=>$_neworedit,
  'POSTTITLE'=>htmlentities(stripslashes($post['title']), ENT_NOQUOTES, 'UTF-8'),
  'QUICK_EDIT_PL'=>$last10PL->show(),
  'STORY_TOPICS' =>$stTopLst,
  'POSTCONTENT'  =>$post['story'],
  'POSTEXTENDED' =>$post['extended_story'],
  'STORY_STATUS_PICKLIST'=>$statSelObj->show(),
  'SCHEDULED_4_DAY'=>$_scheduled4date[2],
  'SCHEDULED_4_MONTH'=>$_scheduled4date[1],
  'SCHEDULED_4_YEAR'=>$_scheduled4date[0],
  'REF_LIST'=>$_refList,
  'ALLOW_COMMENTS_CHECKED'=>'',
  'ALLOW_PINGS_CHECKED'=>'',
  'X_COM_#'=>(empty($post['id'])?0:$Blog->getCommentCntForPost($post['id'])),
  'X_TB_#'=>(empty($post['id'])?0:$Blog->getTBackCntForPost($post['id']))
  )
);
?>