<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

$_path = '../';
include($_path."config.inc.php");
include($_path."startup_db.inc.php");
include($_path."lib/xmlrpc.inc"); // uncomment if XML-RPC PHP extension IS NOT loaded
$template = new WTemplate;
$template->setPath('template');
$template->setExtension('html');
$Blog->golive($db);
include("auth.inc.php");
$template->init("publish");

/*
  Publishing a story:
    1. Save it
    2. Syndicate it
    3. Ping content aggregators (weblogs.com, ...)
    4. Rebuild the relevant archives
*/

switch($_REQUEST['step'])
{
  case "save":
    if(!empty($_REQUEST['p']))
    {
      // assign to more convenient variable
      $storyData = $_REQUEST['p'];
      if(empty($storyData['allow_comments']))
        $storyData['allow_comments']='0';
      if(empty($storyData['allow_pings']))
        $storyData['allow_pings']='0';
      // process scheduling date:
      if(!empty($storyData['scheduled_for']['day']) && !empty($storyData['scheduled_for']['month']) && !empty($storyData['scheduled_for']['year']))
      {
        $storyData['scheduled_for_date'] = $storyData['scheduled_for']['year'].'-'.$storyData['scheduled_for']['month'].'-'.$storyData['scheduled_for']['day'];
      }
      $storyData['author_id'] = $loggedUserData['id'];
      $ID = $Blog->post($storyData);
      if(!empty($ID))
      {
        $MSG = "Your story has been saved successfully.";
        if(in_array($storyData['status'],array(2,4)))
        {
          if(!empty($storyData['trackback_url']))
          { 
            $trackbackResp = trackback_others($Blog,$ID,$storyData);
            list($tbUrl, $tbResp) = each($trackbackResp);
            writelog($db, "Attempt to trackback ".$tbUrl.". Error code: ".$tbResp[0].", message: ". $tbResp[1]);
            $MSG .= 'Trackbacked '.$tbUrl.'. Response: '.$tbResp[1].'<br/>';
          }
          $nextStep = 'cache';
        }
      }
      else
      {
        $MSG = "So sorry, but your story hasn't been saved due to technical problems.";
      }
    }
    else
      $MSG = 'Invalid request.';
  break;
  case "cache":
    $ID = $_REQUEST['id'];
    if(!empty($ID))
    {
      $storyData = $Blog->getSinglePost($ID);
      $storyTopics = $Blog->listStoryTopics($ID);
      if(in_array($storyData['status'],array(2,4)))
      {
        cache_single($Blog,$ID,'../');
        cache_main($Blog,$ID,'../');
        if(!empty($storyTopics) && is_array($storyTopics))
        {
          while(list($topID,)=each($storyTopics))
            cacheByTopic($Blog, $topID, '../');
        }
        $MSG = "Relevant story archives were rebuilt successfully.";
      }
      else if($storyData['status'] == '5')
      {
        // Status DELETED = unlink story from the archive
        $sql = "SELECT YEAR(created_on) AS y, MONTH(created_on) AS m FROM cs_story WHERE id=".$ID;
        $res = $db->execute($sql);
        cache_monthly($Blog, $res->fields['m'], $res->fields['y'], '../');
        @unlink('../archive/'.$ID.'.html');
        @unlink('../archive/index.html');
      }
      else
        $MSG = "Archives were not built because your story is not in neither Published nor Archived status. The status is: ".$storyData['status'];
      $nextStep = 'syndicate';
    }
    else
      $MSG = 'Invalid request.';
  break;
  break;
  case "notify":
    if(!eregi("localhost",$Blog->settings['site_url']))
    {
      $ID = $_REQUEST['id'];
      $result = pingRemoteSites($Blog);
      $MSG = 'Ping results:<br/>';
      while(list($site, $res)=each($result))
        $MSG .= $site.' : '.$res[1].'<br/>';
      //$nextStep = 'syndicate';
    }
    else
      $MSG = 'Running on localhost. Not pinging aggregator servers.';
    if($Blog->settings['use_syndication'] == '1')
      //$nextStep = 'syndicate';
  break;
  case "syndicate":
    $rss = $Blog->syndicate('rss');
    $rdf = $Blog->syndicate('rdf');
    $fp=@fopen('../index.xml','w');
    if(is_resource($fp))
    {
      fwrite($fp,$rss);
      fclose($fp);
      $s1=true;
    }
    $fp=@fopen('../index.rdf','w');
    if(is_resource($fp))
    {
      fwrite($fp,$rdf);
      fclose($fp);
      $s2=true;
    }
    if($s1 == true && $s2 == true)
      $MSG = 'Your syndication file has been rebuilt.';
    else
      $MSG = 'One or both of your syndication files failed to be rebuilt. Please make sure they are writable (CHMOD 0666).';
    $nextStep = 'notify';
  break;
}

$template->replace(
  array(
    "ID"=>$ID,
    "STEP"=>$nextStep,
    "MSG"=>$MSG
  )
);

echo $template->out();
?>