function BookMark(id,cat_id,uri,short_name,long_name,rss_file)
{
  this.id = id;
  this.cat_id = cat_id;
  this.uri = uri;
  this.short_name = short_name;
  this.long_name = long_name;
  this.rss_file = rss_file;
}


function populateForm(obj)
{
  var els = document.forms.bookmark_detail.elements;
  els['b[id]'].value=obj.id;
  els['b[uri]'].value=obj.uri;
  els['b[short_name]'].value=obj.short_name;
  els['b[long_name]'].value=obj.long_name;
  els['b[rss_file]'].value=obj.rss_file;
  els['b[short_name]'].focus();
  opts = els['b[cat_id]'].options;
  for(i=0;i<opts.length;i++)
  {
    if(opts[i].value == obj.cat_id)
    {
      opts[i].selected = true;
      break
    }
  }
}
  
function filterSearch(column, elValue)
{
  var stats = {
    'All':'',
    'Listed:':'1',
    'Unlisted':'0'
  };
  var isSyndicated = {
    'All':'',
    'Yes':'1',
    'No' :'0'
  };
  var el = document.getElementById("filter["+column+"]");
  if (!el)
  {
    var el = column.target || column.srcElement;
    var n = el.id;
    column = n.slice(n.indexOf('[')+1,n.indexOf(']'));
  }
  var par = el.parentNode;
  var colHeadText = el.childNodes[0].nodeValue;
  var nel = document.createElement("SELECT");
  nel.className='editField';
  switch(column)
  {
    case "category":
      nel.name = 'cat_id';
      nel.options[0] = new Option('All','');
      for( i=0; i<cats.length; i++)
      {
        nel.options[i+1] = new Option(cats[i][1],cats[i][0]);
        if(elValue != undefined && elValue == cats[i][0])
          nel.options[i+1].selected = true;
      }
      par.replaceChild(nel, el);
    break;
    case "status":
      nel.name = 'stat_id';
      var i=0;
      for(member in stats)
      {
        nel.options[i] = new Option(member, stats[member]);
        if(elValue != undefined && elValue == stats[member])
          nel.options[i].selected = true;
        i++;
      }
      par.replaceChild(nel, el);
    break;
    case "syndicated":
      nel.name = 'hasRss';
      var i=0;
      for(member in isSyndicated)
      {
        nel.options[i] = new Option(member, isSyndicated[member]);
        if(elValue != undefined && elValue == isSyndicated[member])
          nel.options[i].selected = true;
        i++;
      }
      par.replaceChild(nel, el);
    break;
  }
  nel.focus();
}

function removeBG(el)
{
  if(el.target)
    el = el.target
  else if(el.srcElement)
    el = el.srcElement
  do
  {
    par = el.parentNode;
    el = par;
  }
  while(par.tagName != 'TR');
  var tbl = document.getElementById('bgroupTable');
  try
  {
    for(i=1;i<tbl.rows.length;i++)
    {
      if(tbl.rows[i] == par)
      {
        tbl.deleteRow(i);
        break;
      }
    }
  }
  catch(e) {}
}

function swapRows(tbody, idx1, idx2)
{
  try
  {
    var tbl = tbody.parentNode;
    var r = tbody.rows;
    var l = r.length;
    var a = new Array();
    for(i=0;i<l;i++)
      a[i] = r[i];
    tbl.removeChild(tbody);
    tbody = document.createElement("TBODY");
    tbl.appendChild(tbody);
    for(i=0;i<a.length;i++)
    {
      if(i == idx2)
        tbody.appendChild(a[idx1]);
      else if(i == idx1)
        tbody.appendChild(a[idx2]);
      else
        tbody.appendChild(a[i]);
    }
  }
  catch (x)
  {
    alert(x);
  }
}

function moveRow(el, dir)
{
  do
    el = el.parentNode;
  while(el.tagName != 'TR');
  var tbl = document.getElementById('bgroupTable');
  var tbody = tbl.tBodies[0];
  idx1 = el.rowIndex - 1;
  idx2 = ((dir==1) ? (idx1-1):(idx1+1));
  if(idx2 < 0 || idx2 > (tbl.rows.length - 2)) return false;
  if(tbody.moveRow)
    tbody.moveRow(idx1, idx2);//IE
  else
    swapRows(tbody, idx1, idx2);
}

function moveRowUp(el)
{
  if(el.target)
    el = el.target
  else if(el.srcElement)
    el = el.srcElement
  return moveRow(el, 1);
}

function moveRowDown(el)
{
  if(el.target)
    el = el.target
  else if(el.srcElement)
    el = el.srcElement
  return moveRow(el, 0);
}

function newRow()
{
  var tbl = document.getElementById('bgroupTable');
  var oRow = tbl.insertRow(-1);
  oRow.align='CENTER';
  var oCell = oRow.insertCell(-1);
  var oFld = document.createElement("INPUT");
  oFld.type = 'text';
  oFld.name = 'bg[new][]';
  oFld.className = 'editField';
  oCell.appendChild(oFld);
  oCell = oRow.insertCell(-1);
  var oImg = document.createElement("IMG");
  oImg.src = 'gfx/delete.jpg';
  oImg.border=0;
  var oHref = document.createElement('A');
  oHref.href = '#';
  if(window.addEventListener)
    oHref.addEventListener("click", removeBG, false);
  else if(window.attachEvent)
    oHref.attachEvent("onclick",removeBG);
  oHref.appendChild(oImg);
  oCell.appendChild(oHref);
  oCell = oRow.insertCell(-1);
  oImg = document.createElement("IMG");
  oImg.src = 'gfx/arrow_up.jpg';
  oImg.border=0;
  oHref = document.createElement('A');
  oHref.href = '#';
  if(window.addEventListener)
    oHref.addEventListener("click", moveRowUp, false);
  else if(window.attachEvent)
    oHref.attachEvent("onclick",moveRowUp);
  oHref.appendChild(oImg);
  oCell.appendChild(oHref);
  oImg = document.createElement("IMG");
  oImg.src = 'gfx/arrow_down.jpg';
  oImg.border=0;
  oHref = document.createElement('A');
  oHref.href = '#';
  if(window.addEventListener)
    oHref.addEventListener("click", moveRowDown, false);
  else if(window.attachEvent)
    oHref.attachEvent("onclick",moveRowDown);
  oHref.appendChild(oImg);
  oCell.appendChild(oHref);
}



function addClassName(el, sClassName) {
  var s = el.className;
  var p = s.split(" ");
  var l = p.length;
  for (var i = 0; i < l; i++) {
    if (p[i] == sClassName)
      return;
  }
  p[p.length] = sClassName;
  el.className = p.join(" ");
      
}

function removeClassName(el, sClassName) {
  var s = el.className;
  var p = s.split(" ");
  var np = [];
  var l = p.length;
  var j = 0;
  for (var i = 0; i < l; i++) {
    if (p[i] != sClassName)
      np[j++] = p[i];
  }
  el.className = np.join(" ");
}

function loadFeed(el)
{
  var url = el.options[el.options.selectedIndex].value;
  if(url == '') return false;
  var xmlHttp = XmlHttp.create();
  try
  {
    //xmlHttp.open("GET", "newsreader.php?url="+url, true);// async
    xmlHttp.open("GET", "lib/magpierss/newsreader.php?url="+url, true);// async
  }
  catch (e)
  {
    alert("Could not open "+url+". "+e);
    return false;
  }
  xmlHttp.onreadystatechange = function ()
  {
    if(xmlHttp.readyState == 4)
    {
      var feed = xmlHttp.responseText;
      if(!feed)
      {
        alert("An error occured getting server data.");
        return false;
      }
      document.getElementById("newsbox").innerHTML = feed;
    }
  };
  // call in new thread to allow ui to update
  window.setTimeout(function () {
    xmlHttp.send(null);
  }, 10);
}

function tglBlock(el)
{
  var par = el.parentNode;
  for(i=0;i<par.childNodes.length;i++)
  {
    if(par.childNodes[i].tagName == 'DIV')
    {
      var div = par.childNodes[i];
      break;
    }
  }
  if(div)
  {
    if(div.style.display == 'block') 
      div.style.display = 'none'; 
    else 
      div.style.display = 'block';
  }
}
