<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

error_reporting(0);

$_path = '../';
include($_path."config.inc.php");
include($_path."startup_db.inc.php");
include($_path."lib/xmlrpc-2.5.php");
include("lib/magpierss/rss_fetch.inc");
include("lib/magpierss/rss_utils.inc");
include("lib/xmlrpc_methods.php");
include("lib/auth.lib");

$Blog->golive($db);
$xmlrpc_request = XMLRPC_parse($HTTP_RAW_POST_DATA);

$methodName = XMLRPC_getMethodName($xmlrpc_request);
$params = XMLRPC_getParams($xmlrpc_request);
if(isset($xmlrpc_methods[$methodName]))
{
  // first, authenticate, then allow further access, unless wordsmith.signOn method is called
  // $params[0] must always be Session Id
  if(in_array($methodName, array('wordsmith.signOn', 'wordsmith.listBookmarkCategories', 'wordsmith.listBookmarks', 'wordsmith.isBookmarkFresh')))
  {
    $xmlrpc_methods[$methodName]($params);
  }
  else
  {
    $uData = wsGetUserData($db, $params[0]);
    if(!empty($uData) && is_array($uData) && !empty($uData['id'])) // paranoid enough?
    {
      wsUpdateSession($db, $params[0]);
      $xmlrpc_methods[$methodName]($params);
    }
    else
    {  XMLRPC_error("1", "WORDSMITH server refused connection: You are not logged in, therefore you can't ask for any data.", WEBLOG_XMLRPC_USERAGENT); }
  }
}
else
{
  $xmlrpc_methods['method_not_found']($methodName);
}
?> 