<?php
/*----------------------------------------------------------------------------\
|                    Wordsmith - Weblog & Publishing Tool                     |
|                             Version 1.1 BETA                                |
|-----------------------------------------------------------------------------|
|                         Created by Tomas kohl                               |
|                      (http://tomaskohl.com/wordsmith)                       |
|                    Copyright (c) 2003 - 2004 Tomas Kohl                     |
|-----------------------------------------------------------------------------|
| This software is provided "as is", without warranty of any kind, express or |
| implied, including  but not limited  to the warranties of  merchantability, |
| fitness for a particular purpose and noninfringement. In no event shall the |
| authors or  copyright  holders be  liable for any claim,  damages or  other |
| liability, whether  in an  action of  contract, tort  or otherwise, arising |
| from,  out of  or in  connection with  the software or  the  use  or  other |
| dealings in the software.                                                   |
|                                                                             |
| This  software is  available under the BSD license                          |
|----------------------------------------------------------------------------*/

// incoming trackback
error_reporting(0);
include("config.inc.php");
include("startup_db.inc.php");
$db->debug=0;
$Blog->golive($db);
if(!$Blog->isLive())
{
  $error = '1';
  $msg = 'This site is down for the moment. Please try again later.';
}
else
{
  if($Blog->isBanned($_SERVER['REMOTE_ADDR']) && $Blog->handle_banned!='BAN_NONE')
  {
    $error = '1';
    $msg = "You have been BANNED!";
  }
  else if($Blog->settings['allow_pings'] != '1')
  {
    $error = '1';
    $msg = 'This site does not accept trackback at this moment.. Please check '.$Blog->settings['site_url'].' for possible policy changes later.';
  }
  else
  {
    $post = $Blog->getSinglePost($_REQUEST['story_id']);
    if($post['allow_pings'] != '1')
    {
      $msg = 'This post is closed for trackback. Please check '.$Blog->settings['site_url'].' for possible policy changes later.';
    }
    else
    {
      $story_id = $_REQUEST['story_id'];
      $url = $_REQUEST['url'];
      $title = strip_tags($_REQUEST['title']);
      if(empty($title))
        $title = $url;
      $excerpt = strip_tags($_REQUEST['excerpt']);
      $excerpt = (strlen($excerpt) > 255) ? substr($excerpt, 0, 252).'...' : $excerpt;
      $blog_name = $_REQUEST['blog_name'];

      if(!empty($story_id) && !empty($excerpt) && !empty($url))
      {
        if($Blog->addTrackBackToPost($story_id,$url,$blog_name,$title,$excerpt))
        {
          cache_single($Blog,$story_id);
          cache_main($Blog,$story_id);
          $error = '0';
        }
        else
        {
          $error = '1';
          $msg = 'Trackback could not be registered due to a database problem. Maybe you trackbacked this story already?';
        }
      }
      else
      {
        $error = '1';
        $msg = "You must provide these parameters: story_id, excerpt, blog_name, url. Got '$story_id', '$excerpt', '$blog_name', '$url'";
        $msg = str_replace("''","NULL",$msg);
      }
    }
  }
}
writeLog($db, "Trackback attempt from ".$_SERVER['REMOTE_ADDR']." for story ID $story_id. Result: ".(empty($msg)?"OK":$msg));
header("Content-type: text/xml; charset=UTF-8");
echo '<?xml version="1.0" encoding="UTF-8"?>
<response>
<error>'.$error.'</error>
<message>'.$msg.'</message>
</response>';
?>